<?php

require_once(globalStatic::$root_directory.'include/TemplatePrint/TemplatePrintMoreInfo.php');
include(globalStatic::$root_directory.'include/VarGeneralBol/TemplatePrintSql.php');
crm_load_function_file('getTaxDetailsForProduct','include/utils','InventoryUtils');
//include('include/config.inc.php');
 class TemplatePrint
 {
    private $focus;
    private $tabname;
    private $tabid;
    private $printid;
    private $recordid;
    private $adb;
    private $productTotal=0;//产品金额合计
    private $companyResult=null;//ld_organizationDetails表的查询信息
    private $expenseTotal=0;//费用报销金额合计
	private $commissionSalesOrderTotal=0;//佣金单合同金额
	private $commissionAmount=0;//佣金单已收金额
	private $commissionInvoiceTotal=0;//佣金单发票金额
    private $replacespacevalue;
    private $printUitypeTables;
    private $reminds_ruleid;//提醒规则id
    private $printfilename;//打印文件名称
  
  public function setRemindsRuleid($reminds_ruleid,$recorid)
  {
     $sql='select remindcontent from ld_automaticreminds  where id=?  ';
     $result=$this->adb->pquery($sql,array($reminds_ruleid));
     $content=$this->adb->query_result($result,0,0);
     $this->printfilename='remindemail_'.$reminds_ruleid.'.html';
     $filehandle=fopen(globalStatic::$root_directory.'templatePrintFile/'.$this->printfilename,'w+');
     fwrite($filehandle,'<html><body>');
     fwrite($filehandle,$content);
     fwrite($filehandle,'</body></html>');
     fclose($filehandle);
     $this->recordid=$recorid;
  }
    /**
     * edit:can
     * date:20130820
     * $tabname:模块名称
     * $tabid:模块id
     * $printid:打印单据id
     * $recordid:单据id
     * */
    public function  __construct($tabname,$tabid,$printid,$recorid,$adb,$reminds_ruleid=0,$fromFieldCode="no")
    {
        $this->tabname=$tabname;
        $this->tabid=$tabid;
        $this->printid=$printid;
        $this->recordid=$recorid;
        $this->adb=$adb;
        $this->reminds_ruleid=$reminds_ruleid;
        $this->focus=CRMEntity::getInstance($tabname);
        /**
         * 更新操作
         * edit:can
         * date:20131209
         * reason:打印变量为空时可设置替换内容(V3.1)
         * */
         if(empty($this->reminds_ruleid)&&$fromFieldCode=='no')
         {
            $sql='select replacespacevalue from ld_templateprint where templateprintid=?';
            $result=$this->adb->pquery($sql,array($printid));
            if($this->adb->num_rows($result)>0)
            {
                $this->replacespacevalue=$this->adb->query_result($result,0,0);
            }
             $sql="select printfilename from ld_templateprint where templateprintid=?";
            $result=$this->adb->pquery($sql,array($this->printid));
            $this->printfilename=$this->adb->query_result($result,0,0);

             global $weixin_user;

             if(!file_exists(globalStatic::$root_directory.'templatePrintFile/'.$this->printfilename))
              {
                  /* zxm 2020-1106 手机端生成pdf格式 返回json*/
                if($weixin_user->environment == 'weixinh5'){
                    ConvertTojsonString(-1, array(), getFixedLabel('TEMPLATEFILEISMISSING'));
                }
                echo getFixedLabel('TEMPLATEFILEISMISSING');
                exit();
              }
            if(!is_readable(globalStatic::$root_directory.'templatePrintFile/'.$this->printfilename))
            {
                /* zxm 2020-1106 手机端生成pdf格式 返回json*/
                if($weixin_user->environment == 'weixinh5'){
                    ConvertTojsonString(-1, array(), getFixedLabel('TEMPLATEFILEISMISSING'));
                }
                echo getFixedLabel('TEMPLATEFILEISMISSING');
                exit();
            }
         }else if(empty($this->reminds_ruleid)&&$fromFieldCode=='yes'){
             //zxm 2021-0412 二维码字段类型生成二维码
			 $template_sql = "select * from ld_qrcode_template where fieldid=?";
             $template_res = $adb->pquery($template_sql,[$printid]);
             $template_nums = $adb->num_rows($template_res);

             if($template_nums<=0){
                 ConvertTojsonString(-1, array(), '二维码模板没有数据，请先行设置！');
             }
             $template = $adb->query_result_rowdata($template_res,0);
             $template_content = $template['template_content'];
             file_put_contents(globalStatic::$root_directory . 'templatePrintFile/tempcodeprint'.$printid.'.html',$template_content);
             $this->replacespacevalue = $template['replacesplacevalue'];
             $this->printfilename = 'tempcodeprint'.$printid.'.html';
         }
         else
         {
            $sql='select remindcontent from ld_automaticreminds  where id=?  ';
            $result=$adb->pquery($sql,array($reminds_ruleid));
            $content=$adb->query_result($result,0,0);
            $this->printfilename='remindemail_'.$reminds_ruleid.'.html';

            $filehandle=fopen(globalStatic::$root_directory . 'templatePrintFile/'.$this->printfilename,'w+');
            fwrite($filehandle,'<html><body>');
            fwrite($filehandle,$content);
            fwrite($filehandle,'</body></html>');
            fclose($filehandle);
			
         }  
       
    }
    /**
     * 获取审批历史
     * */
    private function  getApproveHistory()
    {
        
      
          $approve = new Approve($this->tabname);
		$approvemod = $approve->getApproveModuleInfo();
	   $approvehtml='';
		$approvelog = $approve->approveLog($this->recordid);

        //@edit:liushuai,2020-8-6,reason:1000994/打印模板定制审批历史中增加“手写签名”变量
        //判断手写签名是否开启
        global $global_regop;
        if(!isset($global_regop))
            $global_regop=RegOp::getInstance();
        $autograph = $global_regop->gethandleWriteSign_interface();
		if(!empty($approvelog))
        {
            $approve_autograph_html = '';
            if ($autograph == 1) {
                $approve_autograph_html = '</th><th style="background: #efefef none repeat scroll 0 0;height: 30px;padding: 0 3px;text-align: left;white-space: nowrap;">'.getFixedLabel('handwriting');
            }
//            //@edit:liushuai,2020-8-11,reason:0042362: （https://61mis.com/kfbtest [^]）合同订单SO206打印预览时，审批历史中应该不显示滚动条（ <div style="overflow: auto; max-height: 800px;">）
            $approvehtml.=' <table class="D_pop_bod" cellspacing="1" cellpadding="1" border="0" style="background-color:inherit;width:98%;">
                <tr>
                <td style="background-color:transparent;padding:0px;">
                <div style="max-height: 800px;">
                 <table width="100%" class="listdata" cellspacing="1" cellpadding="0" border="0" style="background-color: #ddd;margin-top:3px;color: #333;font-size: 12px">
                    <tr>
                        <th  style="background: #efefef none repeat scroll 0 0;height: 30px;padding: 0 3px;text-align: left;white-space: nowrap;">'.getFixedLabel('SEQUENCE').'</th>
                        <th style="background: #efefef none repeat scroll 0 0;height: 30px;padding: 0 3px;text-align: left;white-space: nowrap;">'.getFixedLabel('OPERATING').'</th>
                        <th style="background: #efefef none repeat scroll 0 0;height: 30px;padding: 0 3px;text-align: left;white-space: nowrap;">'.getFixedLabel('APPROVALSTEP').'</th>
                        <th style="background: #efefef none repeat scroll 0 0;height: 30px;padding: 0 3px;text-align: left;white-space: nowrap;">'.getFixedLabel('OPERATOR').'</th>
                        <th style="background: #efefef none repeat scroll 0 0;height: 30px;padding: 0 3px;text-align: left;white-space: nowrap;">'.getFixedLabel('APPROVALRESULT').'</th>
                        <th style="background: #efefef none repeat scroll 0 0;height: 30px;padding: 0 3px;text-align: left;white-space: nowrap;">'.getFixedLabel('NEXTOPERATOR').'</th>
                        <th style="background: #efefef none repeat scroll 0 0;height: 30px;padding: 0 3px;text-align: left;white-space: nowrap;">'.getFixedLabel('APPROVALSUGGESTION').$approve_autograph_html.'</th>
                        <th style="background: #efefef none repeat scroll 0 0;height: 30px;padding: 0 3px;text-align: left;white-space: nowrap;">'.getFixedLabel('OPERATTIME').'</th>
                    </tr> ';
            $approvenum=sizeof($approvelog);
           
            foreach($approvelog as $header=>$approve)
            {
                //拼接手写签名<td>
                foreach($approve['stepinfo'] as $stepindex=>$stepinfo)
                {
                    $approve_autograph_html = '';
                    if ($autograph == 1) {
                        $approve_autograph_html .= '</td><td style="background-color: #fff;height:30px">';
                        if ($approve['APPROVEAUTOGRAPHPATH'] != '') {
                            $approve_autograph_html .= '<img style="cursor:pointer;width:100px;height:200px;"  border=0 src="'.$stepinfo['APPROVEAUTOGRAPHPATH'].'">';
                        }
                    }
                    $approvehtml.='<tr bgcolor="white">';
                    if($stepindex==0)//序号和操作列
                        $approvehtml.=' <td rowspan='.$approve['operatecol_rowspan'].' align="center"  style="background-color: #fff;height:30px">'.
                            $approve['seqno'].'</td>
                            <td style="background-color: #fff;height:30px" rowspan='.$approve['operatecol_rowspan'].'>'.
                            $approve['operatename']
                           .'</td>';
                  $stepcol_rowspan=$stepinfo['stepcol_rowspan'];
                  
                     if(!empty($stepcol_rowspan)&&$stepcol_rowspan>0)  //审批步骤列
                       
                        $approvehtml.='<td rowspan='.$stepinfo['stepcol_rowspan'].' style="background-color: #fff;height:30px">'.
                        $stepinfo['STEPNAME']
                        .'</td> ';
                        
                        $approvehtml.='<td style="background-color: #fff;height:30px">'.
                        $stepinfo['OPERATOR']
                       .'</td>
                        <td style="background-color: #fff;height:30px">'.
                        $stepinfo['APPROVERESULT']
                       .'</td>
                        <td>'.
                        $stepinfo['NEXTSTEPBYNAME']
                       .'</td>
                        <td style="background-color: #fff;height:30px">'.
                        $stepinfo['DESCRIPTION']
                        .$approve_autograph_html
                       .'</td>
                        <td nowrap="nowrap" style="background-color: #fff;height:30">'.
                        $stepinfo['CREATEDTIME']
                        .'</td>  </tr>';
                }
                
            }
            $approvehtml.=' </table> </div></td></tr> </table>';
		}
        
        return $approvehtml;
    }
    /**
     * edit:can
     * date:20130821
     * reason:金额转换为大写
     * */
    private function ConvertTotalToUpper($data)
    {
        global $adb;
        
        //crm_load_class_file('cls_Money_Upper','include/TemplatePrint');
      crm_load_class_file('cls_Money_ToUpper','include/TemplatePrint');
     // $obj=new cls_Money_ToUpper();
     if(empty($data)){
        $data=0.00;
     }
       if($data<0)
       {
            $data=0-$data;
            $sql='select func_changeToCapitalRMB('.$data.') as uppermoney ';
            $result=$adb->pquery($sql,array());
          
          return "负".$adb->query_result($result,0,'uppermoney');
       }
      else
      {
         $sql='select func_changeToCapitalRMB('.$data.') as uppermoney ';
         
          $result=$adb->pquery($sql,array());
          
          return $adb->query_result($result,0,'uppermoney');
          
      }
    }
    private  function getDecimalTwoVal($data)
    {
        $integ=0;
        $digit='';
        if(strpos($data,'.')>0)
        {
             $integ=substr($data,0,strpos($data,'.'));
             $digit=substr($data,strpos($data,'.')+1);
            
            if(strlen($digit)>2)
            {
                $nextdig=substr($digit,2,1);
                
                if($nextdig>=5)
                {
                    $digit=substr($digit,0,2);
                    $digit+=1;
                    if($digit==100)
                    {
                        $integ+=1;
                        $digit='00';
                    }
                }
                else
                {
                    $digit=substr($digit,0,2);
                }
                
            }
            
        }
        else
        {
            $integ=$data;
            $digit='00';
        }
        $j=1;
        $retdata='';
        $step=strlen($integ)/3;
        $stepmod=strlen($integ)%3;
        while($j<$step)
        {
            //逆序取3个字符
            $retdata=','.substr($integ,strlen($integ)-$j*3,3).$retdata;
            $j++;
        }
       
          if($stepmod==0)
            $retdata=substr($integ,strlen($integ)-$j*3,3).$retdata;
          if($step>=1)
          {
             if($stepmod>0)
               {
                   $retdata= substr($integ,0,$stepmod).$retdata;
               }
          }
          else
          {
             $retdata=$integ;
          }
          
     
        $integ=$retdata.'.'.$digit;
        return $integ;
        
    }
    /**
     * 更新操作
     * edit:can
     * date:20131216
     * reason:皓星收款通知
     * */
    function createDebitNote()
    {
        $totalamount=0;
        $focus=CRMEntity::getInstance($this->tabname);
        $detailtable=$focus->Detail_table;
        $detailtablescf=$focus->Detail_table_scf;
        
        $sql='select paymentplan.plandate,ld_productcf.cf_853,ld_salesorderdetailscf.sendarea,paymentplan.amount
         from ld_salesorder 
        inner JOIN ld_salesorderdetail on ld_salesorderdetail.id=ld_salesorder.salesorderid
        inner JOIN ld_products on ld_products.productid=ld_salesorderdetail.productid 
        INNER JOIN ld_productcf on ld_productcf.productid=ld_products.productid 
        INNER JOIN ld_salesorderdetailscf on ld_salesorderdetailscf.lineitem_id=$detailtable.lineitem_id 
        INNER JOIN 
        (
            select salesorderid ,date_format(plandate,\'%Y年%m月\') as plandate,ifnull(amount,0.00) as amount
            from ld_paymentplan 
					inner join 
                    (select accountid ,
						case when IFNULL(plandate,\'\' )=\'\' then date_format(CURDATE(),\'%Y年%m月\') 
				        else date_format(plandate,\'%Y年%m月\') end as pplandate from ld_paymentplan where   paymentplanid=?
                    ) as curpaymentplan
					  on curpaymentplan.accountid=ld_paymentplan.accountid 
					 where date_format(ld_paymentplan.plandate,\'%Y年%m月\')=curpaymentplan.pplandate  and deleted=0
        ) as paymentplan 
        on paymentplan.entitytypeid=ld_salesorder.salesorderid
        where ld_salesorder.deleted=0 and ld_products.deleted=0
        order  by paymentplan.plandate  asc';
        //echo $sql;
        $result=$this->adb->pquery($sql,array($this->recordid));  
        //$printhtml.='<div align="right">人民币<strong>RMB</strong><'  
        $printhtml.='<table  style="width:100% ;border-collapse:collapse;"  >';
        $printhtml.='<tr> 
                        <td style="border-top:1px solid;border-bottom:1px solid;font-weight:bold;width:80%;border-right:1px solid;text-align:center" colspan="3">摘要Particulars</td>';
        $printhtml.='<td style="border-top:1px solid;border-bottom:1px solid; width:20%;text-align:center; font-weight:bold"> 金额 Amount</td></tr>';
        
        $signal='@';
        for($i=0;$i<$this->adb->num_rows($result);$i++)
        {
            $productname=$this->adb->query_result($result,$i,'cf_853');
            $plandate=$this->adb->Query_result($result,$i,'plandate');
            $amount=$this->adb->query_result($result,$i,'amount');
            $sendarea=$this->adb->query_result($result,$i,'sendarea');
            $codes=explode('Car Park',$productname);
            $unit='个';//单位
            $printhtml.='<tr>';
            if($i==0)
                $printhtml.='<td>租金</td>';
            else if($i==1)
            {
                $printhtml.='<td>'.$plandate.'</td>';
            }
            else
            {
                $printhtml.='<td>&nbsp;</td>';
            }
            if(sizeof($codes)<2)
            {
                $unit='平方米';
            }
            $everymonth=$amount/$sendarea;
            
            $printhtml.='<td>'.$productname.'</td>';
            $printhtml.='<td style="border-right:1px solid">'.$this->getDecimalTwoVal($sendarea).$unit.$signal.$this->getDecimalTwoVal($everymonth).'元/'.$unit.'/月</td>';
            $printhtml.='<td style="text-align:right;font-weight:bold">'.$this->getDecimalTwoVal($amount).'</td>';
            $printhtml.='</tr>';
            $totalamount+=$amount;
        }
        if($this->adb->num_rows($result)==1)
        {
            $printhtml.='<tr><td>'.$plandate.'</td><td>&nbsp;</td><td style="border-right:1px solid;">&nbsp;</td></tr>';
        }
        $printhtml.='<tr><td>&nbsp;</td><td>&nbsp;</td><td style="border-right:1px solid;">&nbsp;</td></tr>';
        $printhtml.='<tr><td>&nbsp;</td><td>&nbsp;</td><td style="border-right:1px solid;">&nbsp;</td></tr>';
        $printhtml.='<tr> <td colspan="3" style="border-top:1px solid;border-bottom:1px solid;border-right:1px solid ;font-weight:bold;text-align:center">';
        
        $printhtml.='合计Total:(大写）:&nbsp;&nbsp;'.$this->ConvertTotalToUpper($totalamount).'</td>';
        $printhtml.='<td style="border-bottom:1px solid;border-top:1px solid ;font-weight:bold;text-align:right">'.$this->getDecimalTwoVal($totalamount).'</td></tr>';
        $printhtml.='</table>';
        return $printhtml;
    }
    /**
     * edit:can
     * reason:条形码打印
     * $mainFocus:当前打印模块对象
     * 目前只支持字段属于当前打印模块
     * */
    private function createBarCode($var,$mainFocus)
    {
        //$var格式：[var.(Function)_salesorder:dianshang_orderno:salesorder]
        $variables=explode(':',$var);
  
        $strs=explode('_',$variables[0]);
       
        $tablename='ld_'.$strs[1];//表名
       
        $columnname=$variables[1];//字段名称
        $printtableid='';
        $strlen=strpos($variables[2],']');//
        $module= substr($variables[2],0,$strlen);//模块名称
       
        if(strtolower($module)!=strtolower($this->tabname))//如果条形码模块不等于当前打印模块
        {
            return '';
        }
     
        foreach($mainFocus->tab_name_index as $maintablename=>$tableid )
        {
            if(strtolower($maintablename)==strtolower($tablename))
            {
                $printtableid=$tableid;
                break;
            }
        }
        if(!empty($printtableid))
        {
            $sql="select $columnname from $tablename where $printtableid=?";
          
            $result=$this->adb->pquery($sql,array($this->recordid));
            $barcode=$this->adb->query_result($result,0,0);
            if(!empty($barcode))
                return '<img  style="width:1000px" src="barcode/create.php?codebar=BCGcode39&text='.$barcode.'">';
            else
                return '';
            

        }
        else 
        {
            return '';
        }
        
    }
    /**
     * edit:can
     * reason:服务合同或合同订单应收款（已收款)
     * $type=1:应收款
     * */
    private function getBillAmount_ByOrder($mainFocus,$type='1')
    {
        if($this->tabname=='SalesOrder'||$this->tabname=='ServiceContracts')
        {
            $sql='select total,conversion_rate,currency_id,currency_symbol from '.$mainFocus->table_name.' where '.$mainFocus->table_index.'=?';
            $result=$this->adb->pquery($sql,array($this->recordid)) ;
            $ordercurrency_id=$this->adb->query_result($result,0,'currency_id');
            $orderconversion_rate=$this->adb->query_result($result,0,'conversion_rate');
            $ordersymbol=$this->adb->query_result($result,0,'currency_symbol');
            $order_amount=$this->adb->query_result($result,0,'total');
            $sql='select sum(if(ld_cashbill.currency_id>1 ,amount/ifnull(ld_cashbill.conversion_rate,1.000),ifnull(ld_cashbill2paymentplan.amount,0))) as amount from ld_cashbill left join ld_cashbill2paymentplan
            on ld_cashbill.cashbillid=ld_cashbill2paymentplan.cashbillid 
             left join '.$mainFocus->table_name.' on '.$mainFocus->table_name.'.'.$mainFocus->table_index.'=ld_cashbill2paymentplan.entitytypeid
              where ld_cashbill.deleted=0 and ld_cashbill2paymentplan.entitytypeid=? group by ld_cashbill2paymentplan.entitytypeid';
            $cashbillresult=$this->adb->pquery($sql,array($this->recordid));
            $cashbillamount=0.00;
            if($this->adb->num_rows($cashbillresult)>0)
            {
                $cashbillamount=$this->adb->query_result($cashbillresult,0,'amount');
                $cashbillcurrency_id=$this->adb->query_result($cashbillresult,0,'currency_id');
                if($cashbillcurrency_id!=1)
                {
                    $cashbillconversion_rate=$this->adb->query_result($result,0,'conversion_rate');
                    $cashbillamount=$cashbillamount*$orderconversion_rate;//转换成订单金额
                }
            }
           
            if($type=='1')
           {
                $shouldgetamount=$order_amount-$cashbillamount;
                $shouldgetamount=setNumberFormat($shouldgetamount);
                return $ordersymbol.$shouldgetamount;
           }
           else
           {
                return $ordersymbol.$cashbillamount;
           }
        }
        else
        {
            return '';
        }
    }
    /**
     * 客户应收款
     * $mainFcous:当前模块对象
     * */
    private function getBillAmount_ByAccounts($mainFocus)
    {
        if($this->tabname=='Accounts')
        {
            $accountid=$this->recordid;
        }
        else
        {
            $sql='select columnname from  ld_field where tabid=? and uitype=73';
            $result=$this->adb->pquery($sql,array(getTabid($this->tabname)));
            if($this->adb->num_rows($result)>0)
            {
                $columnname=$this->adb->query_result($result,0,0);
                $sql='select '.$columnname. ' from '.$mainFocus->table_name.' where '.$mainFocus->table_index.'=?';
                $result=$this->adb->pquery($sql,array($this->recordid)) ;
                $accountid=$this->adb->query_result($result,0,0);
                 
            }
           
        }
        if(!empty($accountid))
        {
            //客户的订单总额
          $sql="select sum(ifnull(ordertotal,0))  from 
            (
                 select sum(if ( currency_id>1  ,total/IFNULL(conversion_rate,1.00000)  ,ifnull(total,0) ) ) as ordertotal
                 from ld_servicecontracts 
                 where deleted=0 and contract_status<>'已作废'  and accountid=$accountid  GROUP BY accountid
                 UNION 
                select sum( if(currency_id>1,total/IFNULL(conversion_rate,1.0000),ifnull(total,0)))  as ordertotal  from ld_salesorder
                where deleted=0 and sostatus<>'已作废' and accountid=$accountid  GROUP BY accountid
            ) as temp";
           $result=$this->adb->pquery($sql,array());
           $orderTotal=$this->adb->query_result($result,0,0);
           //客户已收款总额
          $sql="select sum(if(currency_id>1,amount/IFNULL(conversion_rate,1.00000),IFNULL(amount,0))) from  ld_cashbill left join ld_cashbill2paymentplan
                    on ld_cashbill.cashbillid=ld_cashbill2paymentplan.cashbillid
                    INNER JOIN 
                    (
                    
                        select servicecontractsid as orderid from ld_servicecontracts
                         where deleted=0 and contract_status<>'已作废'  and accountid=$accountid
                        union 
                        select salesorderid  as orderid from ld_salesorder
                         where deleted=0 and sostatus<>'已作废' and accountid=$accountid
                    )
                    as temp  on ld_cashbill2paymentplan.entitytypeid=temp.orderid   where deleted=0";
          $result=$this->adb->pquery($sql,array());
          $haveamount=0;
          if($this->adb->num_rows($result)>0)
          {
            $haveamount=$this->adb->query_result($result,0,0);
          }
          $shouldgetamount=$orderTotal-$haveamount;
          return '¥'.setNumberFormat($shouldgetamount);

        }
        else
        {
            return '¥0.00';
        }
    }
   
    /**
     * 更新操作
     * edit:can
     * date:20131109
     * reason:浩星添加回款计划没有收完款的打印单
     * */
    private function createNoCashBill()
    {
      
       $totalbalance=0;     
        $sql='select date_format(ld_paymentplan.plandate,\'%Y年%m月\') as plandate,sum(ifnull(amount,0.00)) as amount,
					sum(ifnull(actualamount,0.00)) actualamount 
              from ld_paymentplan 
               inner join
             (select accountid ,case when IFNULL(plandate,\'\')=\'\' then date_format(CURDATE(),\'%Y年%m月\') 
				   else date_format(plandate,\'%Y年%m月\') end as pplandate
                  from ld_paymentplan where   paymentplanid='.$this->recordid.' )  as paymentplan 
				on paymentplan.accountid=ld_paymentplan.accountid where deleted=0 
                 and (paymentstatus=\'未收\' or paymentstatus=\'部分已收\')  
                and  date_format(plandate,\'%Y年%m月\')';
                
            $sql.=' <paymentplan.pplandate group by  date_format(plandate,\'%Y年%m月\')  order  by date_format(plandate,\'%Y年%m月\') asc' ;
     
       $result=$this->adb->pquery($sql);
      // print_r(array($this->recordid,'未收','部分已收'));
       if($this->adb->num_rows($result)<=0)
       {
         return '';
       }
       $printhtml='之前欠款累计如下，请贵司尽快支付：<br>';
       $printhtml.='<table  style="width:100% ;border-collapse:collapse;" >';
       $printhtml.='<tr><td width="25%" style="border-top:1px solid;font-weight:bold" >租赁期</td>
                        <td style="border-top:1px solid;font-weight:bold"  width="25%">应收金额</td>
                        <td width="25%" style="border-top:1px solid;font-weight:bold" >实收金额</td>
                        <td  style="border-top:1px solid;font-weight:bold"  width="25%">余额</td></tr>';
       $tdhtml='<td width="25%" >';
       for($i==0;$i<$this->adb->num_rows($result);$i++)
       {
         $plandate=$this->adb->query_result($result,$i,'plandate');
         $amount=round($this->adb->query_result($result,$i,'amount'),2);
         $actualamount=round($this->adb->query_result($result,$i,'actualamount'),2);
         $balanceamount=$amount-$actualamount;
         $amount=number_format($amount,2);
         $totalbalance+=  $balanceamount;
         $balanceamount=number_format($balanceamount,2);
         $actualamount=number_format($actualamount,2);
         $printhtml.='<tr>';
         if($plandate=='')
         {
            $plandate=$this->replacespacevalue;
         }
         $printhtml.=$tdhtml.$plandate.'</td>'.$tdhtml.$amount.'</td>';
         $printhtml.=$tdhtml.$actualamount.'</td>'.$tdhtml.$balanceamount.'</td>';
         $printhtml.='</tr>';
       }
       
       $printhtml.='<tr><td colspan="3" style="font-weight:bold;border-top:1px solid;border-bottom:1px solid" align="center">总计Total: (大写)&nbsp;&nbsp;'.$this->ConvertTotalToUpper($totalbalance).'</td>
       <td style="font-weight:bold;border-top:1px solid;border-bottom:1px solid">'.number_format($totalbalance,2).'</td></tr>';
       $printhtml.='</table>';
       return $printhtml;
    }
    /**
     * edit:can
     * date:20130930
     * reason:获取费用报销明细
     * */
    private function createExpenseResult()
    {
        $tabid=getTabid('Expense');
        
        $field_sql='select columnname,tablename,fieldtype from  ld_tabdetailfield  where tabid=? and tablename in(\'ld_expensedetailscf\',\'ld_expensedetail\') and presence in(0,2)';
        
       
     $sql=' select ld_expensedetail.expenseid,ld_expensedetail.entitytype ';
      $result=$this->adb->pquery($field_sql,array($tabid));
      $num_rows=$this->adb->num_rows($result);
      for($i=0;$i<$num_rows;$i++)
      {
        $tablename=$this->adb->query_result($result,$i,'tablename');
         $tables[]=$this->adb->query_result($result,$i,'tablename');
         $columnname=$this->adb->query_result($result,$i,'columnname');
         $fieldtype=$this->adb->query_result($result,$i,'fieldtype');
         if($fieldtype=='SelectCurrency')
         {
            $tables[]='ld_currencies';
            $sql.=',ld_currencies.description  as '.$columnname.'_expense';
         }
         else
         
            $sql.=', '.$tablename.'.'.$columnname.' as '.$columnname.'_expense';
      }
      $tables=array_unique($tables);
     $sql.=' from  ld_expensedetail ';
     if(in_array('ld_expensedetailscf',$tables))
     {
        $sql.=' left join ld_expensedetailscf on  ld_expensedetail.expensedetailid=ld_expensedetailscf.expensedetailid ';
     }
     if(in_array('ld_currencies',$tables))
     {
        $sql.=' left join ld_currency_info on  ld_currency_info.id=ld_expensedetailscf.currency_id left join 
                                                ld_currencies 
                                                on ld_currencies.currency_code=ld_currency_info.currency_code  ';
     }
     $sql.='  where expenseid=? order by ld_expensedetail.expensedetailid asc';

        $result=$this->adb->pquery($sql,array($this->recordid));
        return $result;
    }

 
	private function getDetailSourceHaveTotal($entitytypeid){
	   if(!empty($entitytypeid))
       {
             $entitytype=getSalesEntityType($entitytypeid);
             if(!empty($entitytype))
    	       {
    	            $source_focus=CRMEntity::getInstance($entitytype);
                    $table_name=$source_focus->table_name;
                    $table_index=$source_focus->table_index;
    	           	$sql='select received_amount  from '. $table_name .' where  '.$table_index.'='.$entitytypeid;
                    $sum_amount_result=$this->adb->pquery($sql,array());
            		return $this->adb->query_result($sum_amount_result,0,0);
    	       }
              
       }
       return '';
       
	    
	}
	private function getProductcfValue(){
	   $focus=CRMEntity::getInstance($this->tabname);
       $detailtable=$focus->Detail_table;
       $detailtablescf=$focus->Detail_table_scf;
       
		$sql="select $detailtable.taxprice,ld_productcf.cf_1520,ld_productcf.cf_1519,ld_products.productname
             from $detailtable 
				LEFT JOIN ld_products on ld_products.productid = $detailtable.productid
				LEFT JOIN ld_productcf on ld_productcf.productid = ld_products.productid
				where $detailtable.id = ? limit 1;";
		$result=$this->adb->pquery($sql,array($this->recordid));
        if($this->adb->num_rows($result) >= 1){
			$product_info = array(
				'taxprice' => $this->adb->query_result($result,0,'taxprice'),
				'1520' => $this->adb->query_result($result,0,'cf_1520'),
				'1519' => $this->adb->query_result($result,0,'cf_1519'),
				'productname' => $this->adb->query_result($result,0,'productname'),
			);
            return $product_info;
        }else{
            return '';
        } 
	}
	//显示客户首要联系人
	private function getAccountContactInfo(){
		global $adb;
		$sqlcontact='select columnname,tablename,fieldname from ld_field 
					where tabid=6 and tablename in(?,?,?) and presence in(0,2);';
		$resultcontact=$adb->pquery($sqlcontact,array('ld_contactdetails','ld_contactscf','ld_contactaddress'));
		$sqlcontactrows = $adb->num_rows($resultcontact);
		if($sqlcontactrows > 0){
			for($i=0;$i<$sqlcontactrows;++ $i){			
				$cacheacctcontfld['columnnames'][] = $adb->query_result($resultcontact,$i,'columnname');
				$cacheacctcontfld['fieldnames'][] = $adb->query_result($resultcontact,$i,'fieldname');
			}
		}
		$contactcolumns = $cacheacctcontfld['columnnames'];
		$contactfieldnames = $cacheacctcontfld['fieldnames'];
		$vesion = get_versiontrade();
		$columns=implode(',',$contactcolumns);
		if(in_array('bankbranchid',$contactcolumns) && $vesion == 'finance'){
			$columns = str_replace("bankbranchid","ld_bankbranch.bankname as bankbranchid",$columns);
			$sqlcontact = 'select '.$columns.' ,ld_contactdetails.contactid from ld_contactdetails inner join ld_crmentity on ld_crmentity.crmid=ld_contactdetails.contactid
			  left join ld_contactscf on ld_contactscf.contactid=ld_contactdetails.contactid
			  LEFT JOIN ld_bankbranch on ld_bankbranch.bankbranchid = ld_contactdetails.bankbranchid
			  where accountid=? and reference=1 and ld_contactdetails.deleted=0 order by contact_no asc limit 0,1';
		}else{
			
			$sqlcontact = 'select '.$columns.' ,ld_contactdetails.contactid from ld_contactdetails inner join ld_crmentity on ld_crmentity.crmid=ld_contactdetails.contactid
			  left join ld_contactscf on ld_contactscf.contactid=ld_contactdetails.contactid
			  where accountid=? and reference=1 and ld_contactdetails.deleted=0 order by contact_no asc limit 0,1';	
		}
		$resultcontact=$adb->pquery($sqlcontact,array($this->recordid));
		if($adb->num_rows($resultcontact)>0){

			for($i=0;$i<sizeof($contactfieldnames);$i++)
			{
				$result[$contactfieldnames[$i]]=$adb->query_result($resultcontact,0,$contactcolumns[$i]);
			}
		}
		return $result;

	}
	/**
	 * 获取服务合同明细
	 * @reason 2015-10-22
	 * @author cme 
	 */
    private function getServiceProductsInfo()
    {
        $sql="SELECT
        	servicecontracts_start_date,servicecontracts_end_date,ld_products.productname
        FROM
        	ld_paymentplan
        LEFT JOIN ld_servicecontracts ON ld_paymentplan.entitytypeid = ld_servicecontracts.servicecontractsid
        LEFT JOIN ld_servicecontractsdetail ON ld_servicecontractsdetail.id = ld_servicecontracts.servicecontractsid
        LEFT JOIN ld_products ON ld_products.productid = ld_servicecontractsdetail.productid
				WHERE
        	ld_paymentplan.paymentplanid = ?
        ORDER BY
        	ld_servicecontractsdetail.sequence_no ASC
        LIMIT 1;";
        $result=$this->adb->pquery($sql,array($this->recordid));
        if($this->adb->num_rows($result) >= 1){
            return $this->adb->query_result($result,0,'productname') .'，租期为：' . 
            $this->adb->query_result($result,0,'servicecontracts_start_date') . ' 至 ' . $this->adb->query_result($result,0,'servicecontracts_end_date');
        }else{
            return '--';
        } 
    }
	//单据获取产品明细参数
	private function getProductDetailValue($columnname){
		if(!empty($columnname)){
		  $focus=CRMEntity::getInstance($this->tabname);
          $detailtable=$focus->Detail_table;
          
			$query = 'select ld_products.'.$columnname." from $detailtable 
				LEFT JOIN ld_products on ld_products.productid = $detailtable.productid 
				where $detailtable.id = ? ORDER BY $detailtable.sequence_no asc limit 1";
			$result = $this->adb->pquery($query,array($this->recordid));
			if($this->adb->num_rows($result) >= 1){
				return  $this->adb->query_result($result,0,$columnname);
			}else{
				return '--';
			}
		}
	}
	//获取佣金单的原单类型
	private function getCommissionEntityType(){
		global $adb;
		$query = 'select entitytype from ld_commission where commission_id = ? limit 1';
		$result = $adb->pquery($query,array($this->recordid));
		return $adb->query_result($result,0,0);
	}
    /**
	 * 获取佣金单明细
	 * @reason 2015-10-13
	 * @author Chj 
	 */
	private function createCommissionResult(){
		require_once(globalStatic::$root_directory.'modules/Commission/Commission.php');
		$commission = new Commission();
        $tabid=getTabid("Commission");
	
	
	   $sign_date_sql=' ld_commission2paymentscf.due_date as signeddata_commission';
	
	$source_table_name="source_tablename";
		
		$sql="select ld_commission2payment.entitytype,$source_table_name.sourceid as isamount_commission,
                $source_table_name.subject as salesorderid_commission,$source_table_name.`total` as total_commission,
			$sign_date_sql,temp.cashbilldate as cashbilldate_commission,temp.paymentmethod as paymentmethod_commission,
			ld_commission2payment.remark as remark_commission,ld_commission2payment.rate as rate_commission,ld_commission2payment.amount as amount_commission,
           $source_table_name.currency_symbol,$source_table_name.subject as entitytypeid_commission,
			ld_commission.subtotal as subtotal_commission,ld_commission.noamount as noamount_commission,ld_commission.total as comtotal_commission ";
			
          
            
    $field_sql='select columnname,tablename,fieldtype from  ld_tabdetailfield  where tabid=? and tablename in(\'ld_commission2payment\',\'ld_commission2paymentscf\') and presence in(0,2)';
        
   
   
      $result=$this->adb->pquery($field_sql,array($tabid));
      $num_rows=$this->adb->num_rows($result);
   
      for($i=0;$i<$num_rows;$i++)
      {
        $tablename=$this->adb->query_result($result,$i,'tablename');
         $tables[]=$this->adb->query_result($result,$i,'tablename');
         $columnname=$this->adb->query_result($result,$i,'columnname');
         $fieldtype=$this->adb->query_result($result,$i,'fieldtype');
         
         if($fieldtype=='SelectCurrency')
         {
            $tables[]='ld_currencies';
            $sql.=',ld_currencies.description  as '.$columnname.'_commission';
         }
         if($columnname=='entitytypeid')
         {
            //上面sql变量已经添加：$source_table.$subject as entitytypeid_commission
         }
         else
         
            $sql.=', '.$tablename.'.'.$columnname.' as '.$columnname.'_commission';
      }
      $entitynames=getEntitynameByModulename('SalesOrder');
	   $salesorder_subject = $entitynames['fieldname'];
	   $salesorder_source_table=$entitynames['tablename'];
      $entitynames=getEntitynameByModulename('ServiceContracts');
	   $servicecontract_subject = $entitynames['fieldname'];
	   $servicesource_table=$entitynames['tablename'];
       $sourceSql="(select ld_salesorder.salesorderid as sourceid ,$salesorder_subject as subject,total ,currency_symbol from ld_salesorder ";
       
       if($salesorder_source_table!='ld_salesorder')
       {
            $sourceSql.="  left join $salesorder_source_table on $salesorder_source_table.salesorderid=ld_salesorder.salesorderid ";
       }
       $sourceSql.=" UNION  select   servicecontractsid as sourceid,$servicecontract_subject as subject,total,currency_symbol from ld_servicecontracts ";
       if($servicesource_table!='ld_servicecontracts')
       {
         $sourceSql.="  left join $servicesource_table on $servicesource_table.servicecontractsid=ld_servicecontracts.servicecontractsid ";
       }
       $sourceSql.=" )";
      $sql.="  from ld_commission2payment 
			inner join ld_commission on ld_commission2payment.commission_id = ld_commission.commission_id 
            left join ld_commission2paymentscf on ld_commission2paymentscf.commission2payment_id=ld_commission2payment.commission2payment_id
            
			left join $sourceSql
                as $source_table_name on $source_table_name.sourceid = ld_commission2payment.entitytypeid
			left join (
			select cashbilldate,paymentmethod,ld_cashbill2paymentplan.entitytypeid from ld_cashbill 
			inner join ld_cashbill2paymentplan on ld_cashbill.cashbillid = ld_cashbill2paymentplan.CashBillID
			inner join ld_commission2payment on ld_commission2payment.entitytypeid = ld_cashbill2paymentplan.entitytypeid
			inner join ld_commission on ld_commission2payment.commission_id = ld_commission.commission_id
			where ld_commission.commission_id = ? group by cashbilldate order by  cashbilldate desc limit 1
			) as temp on temp.entitytypeid = ld_commission2payment.entitytypeid
			where ld_commission.commission_id = ? ";
       
		
		$result=$this->adb->pquery($sql,array($this->recordid,$this->recordid));
       
        return $result;
	}
	
    /**
     * edit:can
     * date:20130820
     * reason:获取产品信息
     * */
    private function createProductResult()
    {
        require_once(globalStatic::$root_directory.'modules/'.$this->tabname.'/'.$this->tabname.'.php');
        $focus=CRMEntity::getInstance($this->tabname);
        $detailtable=$focus->Detail_table;
        $detailtablescf=$focus->Detail_table_scf;
        
       $sql="select fieldname ,columnname,tablename,uitype from ld_field where tabid=14 and presence in(0,2)";
       $result=$this->adb->pquery($sql,array());
       $productSql=" select 1,$detailtable.productid,$detailtable.entitytype,$detailtable.lineitem_id";
       $maintablename='ld_products';
       $focus=new $this->tabname;
    
       $from=' from '. $focus->table_name. " inner join $detailtable  on $detailtable.id= " .$focus->table_name.'.'.$focus->table_index;
		 /**
		  * 关联关联表自定义表：ld_inventoryproductrelscf
		  * @project 打印模板添加自定义产品字段
		  * @author Tujt 2014-05-07
		  */
		 $from .= " LEFT JOIN $detailtablescf 
							on $detailtablescf.lineitem_id = $detailtable.lineitem_id ";
		 /**
		  * 增加相关源单模块关联语句，源单field定名为：entitysubject
		  * @reason 0009196 打印模版，无法打印源单
		  * @author Tujt 2014-05-29
		  */
		 $entityfld = '';
		 switch($this->tabname){
		    case 'OutboundOrder':
				$sofocus = CRMEntity::getInstance('SalesOrder');
				$link = 'salesorder_no';
				if(!empty($sofocus->list_link_field)){
					$link = $sofocus->list_link_field;
				}
		        $from .= " left  JOIN ld_salesorder as entityorder 
							on entityorder.salesorderid = $detailtable.entitytypeid ";
				$entityfld = " ,$detailtable.entitytypeid as entitytypeid_products,
									entityorder.".$link.' as entitysubject_products';
		        break;
		    case 'Stock':
				$pofocus = CRMEntity::getInstance('PurchaseOrder');
				$link = 'purchaseorder_no';
				if(!empty($pofocus->list_link_field)){
					$link = $pofocus->list_link_field;
				}
		        $from .= " left JOIN ld_purchaseorder as entityorder 
							on entityorder.purchaseorderid = $detailtable.entitytypeid ";
				$entityfld = " ,$detailtable.entitytypeid as entitytypeid_products,
									entityorder.".$link.' as entitysubject_products';
		        break;
			 case 'Invoice':
				$sofocus = CRMEntity::getInstance('SalesOrder');
				$link = 'salesorder_no';
				if(!empty($sofocus->list_link_field)){
					$link = $sofocus->list_link_field;
				}

		        $from .= " left JOIN ld_salesorder as entityorder 
							on entityorder.salesorderid = $detailtable.entitytypeid";

                 //ls 2022-02-22 0050027: （http://crm.extremevision.com.cn:85/crm/index.php [^]）（极视角-李发林）销售发票，详情》打印，产品分录的信息打印不出来(超连接字段为自定义表字段导致的)
                 $entityarray = getEntitynameInfo(getTabid('SalesOrder'));//获取超链接字段信息
                 if ($entityarray['tablename'] == 'ld_salesordercf') {
                     $from .= " LEFT JOIN ld_salesordercf AS entityordercf ON entityorder.salesorderid = entityordercf.salesorderid ";
                     $entityfld = " ,$detailtable.entitytypeid as entitytypeid_products,
									entityorderscf.".$link.' as entitysubject_products';
                 }else{
                     $entityfld = " ,$detailtable.entitytypeid as entitytypeid_products,
									entityorder.".$link.' as entitysubject_products';
                 }

		        break;
			 case 'PurchaseOrder':
				$sofocus = CRMEntity::getInstance('SalesOrder');
				$link = 'salesorder_no';
				if(!empty($sofocus->list_link_field)){
					$link = $sofocus->list_link_field;
				}
		        $from .= " left JOIN ld_salesorder as entityorder 
							on entityorder.salesorderid = $detailtable.entitytypeid ";
				$entityfld = " ,$detailtable.entitytypeid as entitytypeid_products,
									entityorder.".$link.' as entitysubject_products';
		        break;
			case 'PurchaseInvoice':
				$pofocus = CRMEntity::getInstance('PurchaseOrder');
				$link = 'purchaseorder_no';
				if(!empty($pofocus->list_link_field)){
					$link = $pofocus->list_link_field;
				}
		        $from .= " left JOIN ld_purchaseorder as entityorder 
							on entityorder.purchaseorderid = $detailtable.entitytypeid ";
				$entityfld = " ,$detailtable.entitytypeid as entitytypeid_products,
									entityorder.".$link.' as entitysubject_products';
		        break;
		 }
		 /**
		  * 增加服务开始日期、服务到期日两个字段
		  * @reason 0011869 打印模板定制，新增服务合同打印模板，缺少【服务开始日期】、【服务到期日】2个打印变量
		  * @author Tujt 2014-10-13
		  */
		$servicecontractsprintsql = '';
		if($this->tabname == 'ServiceContracts'){
			$servicecontractsprintsql = " ,$detailtable.servicecontracts_start_date 
											as  start_date_products,
										$detailtable.servicecontracts_end_date 
											as end_date_products ";
		}
       $from .=' left join ' .$maintablename.' on '.$maintablename.".productid=$detailtable.productid";
   
       $tables=array();
       $tables[$maintablename]='';
       $tables['ld_crmentity']='';
       for($i=0;$i<$this->adb->num_rows($result);$i++)
       {
           $fieldname=$this->adb->query_result($result,$i,'fieldname');
           $columnname=$this->adb->query_result($result,$i,'columnname');
           $tablename=$this->adb->query_result($result,$i,'tablename');
           $uitype=$this->adb->query_result($result,$i,'uitype');
          if($tablename=='ld_attachments')
          {
            continue;
          }
             
               if(!array_key_exists(strtolower($tablename).$fieldname,$tables))
               {
                  
                   
                      
                      if($uitype==52 ||$uitype==53)
                      {
                        $tables[strtolower($tablename).$fieldname]='';
                        $from .=' left join ld_users as user'.$fieldname .' on user'.$fieldname.'.id='.$tablename.'.'.$columnname;
                         $productSql .=', user'.$fieldname.'.last_name as '.$fieldname.'_products';
                        
                      }
                      else if($uitype==75)
                        {
                            if(!array_key_exists('ld_vendor',$tables))
                             {
                                 $from .=' left join ld_vendor on ld_vendor.vendorid=ld_products.vendor_id';
                                 $tables[strtolower($tablename)]='';
                             }
                               
                              $productSql .=' , ld_vendor.vendorname as '.$fieldname.'_products';
                        }
                      else
                      {
                         //edit:can reason: $productSql .=' , '.$tablename.'.'.$columnname. ' as '.$fieldname.'_products';
                             if(!array_key_exists(strtolower($tablename),$tables))
                            {
                               
                                 if(strtolower($tablename)!='ld_products')
                                 {
                                     $from .=' left join '. $tablename .' on '.$tablename.'.productid=ld_products.productid';
                                     $tables[strtolower($tablename)]='';
                                 }
                                   
                                 
                            }
                             $productSql .=' , '.$tablename.'.'.$columnname. ' as '.$fieldname.'_products';
                      }
                     
                      
                }
                
                elseif(!array_key_exists(strtolower($tablename),$tables))
                {
                    
                     if(strtolower($tablename)!='ld_products')
                     {
                         $from .=' left join '. $tablename .' on '.$tablename.'.productid=ld_products.productid';
                         $tables[strtolower($tablename)]='';
                     }
                       
                      $productSql .=' , '.$tablename.'.'.$columnname. ' as '.$fieldname.'_products';
                }
               
                else
                {
                      
                    if($uitype==56)//产品是否有效
                    {
                        $productSql .=' ,case when  ifnull( '.$tablename.'.'.$columnname.', 0)=0 then '."'是' else   "."'否' end "  .$fieldname.'_products';
                    }
               
                    else
                    {
                      
                        $productSql .=' , '.$tablename.'.'.$columnname.' as '.$fieldname.'_products';
                    }
                    
                }
           } 
           require_once(globalStatic::$root_directory.'modules/'.$this->tabname.'/'.$this->tabname.'.php');
           $focus=new $this->tabname;
           $maintablename=$focus->table_name;
         //  if($this->tabname!='QuotesChange')
          //  $productSql.=' , '.$maintablename.'.taxtype as hdnTaxType_salesorder';
           
           //明细产品定价
            $productSql .=" , $detailtable.listprice as listprice_products";
			/**
			 * 打印，增加含税单价列
			 * @@project PROT106 合同订单录入明细改进
			 * @author Tujt 2014-10-11
			 */
			$productSql .=" ,$detailtable.taxprice as taxprice_products ";
			$productSql .=" , TRUNCATE(($detailtable.quantity*$detailtable.listprice),2) as amount_products";
			$productSql .= $servicecontractsprintsql;
            //数量单位
           // $productSql .=",concat(ifnull(ld_inventoryproductrel.quantity,''),ifnull(ld_products.usageunit,'')) as mergerqty_unit_products";
           //ld_inventoryproductrel.quantity:明细产品数量
           //ld_inventoryproductrel.discount_percent:明细折扣
           //ld_inventoryproductrel.discount_amount:明细直接降价

			  /**
			   * 从ld_producttoolfield表中取出启用的自定义产品字段，
			   * @author Tujt 2014-05-07
			   */
			  ///product tool field
			  $profldsql = 'select columnname,tablename from ld_producttoolfield where presence in (0,2)
                     and( tablename =? or tablename=?) and tabid =? and IFNULL(bigtype,"")<>"image" ORDER BY sequence ';
			  $profldresult = $this->adb->pquery($profldsql,array($detailtable,$detailtablescf,getTabid($this->tabname)));
			  $rows = $this->adb->num_rows($profldresult);
			  if($rows > 0){
				  for($i=0;$i<$rows;++ $i){
					  $profld = $this->adb->query_result($profldresult,$i,'columnname');
                      $invetorytablename=$this->adb->query_result($profldresult,$i,'tablename');
					  $productSql .= ','.$invetorytablename.'.'.$profld.' as '.$profld.'_products';
				  }
			  }
			
			/**
			 * 打印模板中，添加RMB产品相关打印字段
			 * @project PROT99 奥特林：产品明细录入改进
			 * @author Tujt 2014-10-21
			 */
			$deployarray_52 = getSys_deploy(52);
			$isrmbfld = '';
			if(1 == $deployarray_52['deploy_value']){
				$isrmbfld = ",TRUNCATE($detailtable.listprice,2) as rmb_taxprice_products,
							TRUNCATE(($detailtable.quantity*$detailtable.listprice),2) as rmb_taxamount_products
                            ,TRUNCATE($detailtable.rmbprice,2) as rmbprice_products
                            ,TRUNCATE($detailtable.rmbprice*$detailtable.discount_percent/100,2) as eur_price_products
                            ,TRUNCATE($detailtable.tax_rate,2) as tax_rate_products
                            ,TRUNCATE($detailtable.tax_customs,2) as tax_customs_products
                            ,TRUNCATE($detailtable.tax_added,2) as tax_added_products
                            ,TRUNCATE($detailtable.tax_freight,2) as tax_freight_products
                            ,TRUNCATE($detailtable.grossprofit,2) as tax_profit_products ";
			}

			  $productSql .= $entityfld;
           $productSql.=",ld_productbom.subject as productbomid_products,$detailtable.productbomquantity as productbomquantity_products  ,$detailtable.quantity as quantity_products,$detailtable.discount_percent as discount_percent_products
                            ,$detailtable.discount_amount  as discount_amount_products,$detailtable.comment as comment_products
                            ,$detailtable.remark as remark_products ".$isrmbfld ;
		   /**
		    * 如果是bom打印模式，则加载bom打印相应语句
		    * @project PROT127 爱哆哆需求1：产品套餐
		    * @author Tujt 2014-12-03
		    */
		   global $bolBomPrint;
		   $bomsql = '';$bomgroup = '';
		   if($bolBomPrint){
				$bomsql =	",CONCAT(SUBSTRING($detailtable.comment,1,INSTR($detailtable.comment,'=')-1),'(',GROUP_CONCAT(CONCAT(TRUNCATE($detailtable.quantity/SUBSTRING($detailtable.comment,INSTR($detailtable.comment,'*')+1,LENGTH($detailtable.comment)-INSTR($detailtable.comment,'*')),0), ' ',ld_products.`productname`) SEPARATOR '+'),')') AS bomname_products,
				GROUP_CONCAT(CONCAT(TRUNCATE($detailtable.quantity,2),',',ld_products.`productname`,'+')) AS bomprod_products,
				TRUNCATE(SUBSTRING($detailtable.comment,INSTR($detailtable.comment,'=')+1,INSTR($detailtable.comment,'*')-INSTR($detailtable.comment,'=')-1),2) AS bomprice_products,
				SUBSTRING($detailtable.comment,INSTR($detailtable.comment,'*')+1,LENGTH($detailtable.comment)-INSTR($detailtable.comment,'*')) AS bomqty_products,
				TRUNCATE(SUBSTRING($detailtable.comment,INSTR($detailtable.comment,'=')+1,INSTR($detailtable.comment,'*')-INSTR($detailtable.comment,'=')-1)*SUBSTRING($detailtable.comment,INSTR($detailtable.comment,'*')+1,LENGTH($detailtable.comment)-INSTR($detailtable.comment,'*')),2) AS bomamount_products ";
				$bomgroup = " GROUP BY $detailtable.comment  ";
		   }
		   $productSql .= $bomsql;
		   $productSql .= $from;
           $productSql .= " LEFT JOIN ld_productbom on ld_productbom.productbomid=$detailtable.productbomid ";
           $productSql.=' where '.$focus->table_name.'.deleted=0 and '.$focus->table_name.'.'.$focus->table_index.'='.$this->recordid;
		   $productSql .= $bomgroup;
           $productSql .=" ORDER BY $detailtable.sequence_no ";
          
        
           $result=$this->adb->pquery($productSql,array());
           return $result;
    }
    /**
     * edit:can
     * date:20130816
     * reason:打印页面的HTML
     * */
    public function createPrintHtml()
    {
        global $site_URL;
		global $current_user;
       $printfilename=$this->printfilename;
        $printhtml='';
        $focus=CRMEntity::getInstance($this->tabname);
        $detailtable=$focus->Detail_table;
        $detailtablescf=$focus->Detail_table_scf;
       $file_handle=fopen(globalStatic::$root_directory.'templatePrintFile/'.$printfilename,'r');
         $referencemodules=cls_module_uitype::getReferencemodules($this->tabname);
       $referencemodules['users']='';
       $referencemodules['company']='';
    
       foreach($referencemodules as $referencemodule=>$tmpvalue)
       {
        $relatedtabs[strtolower($referencemodule)]='';
       }
      
       $focus->setRelatedTabs($relatedtabs);
       $relatedtabs=$focus->getRelatedTabs();
       $printSQL=$this->createPrintSQL();
        if(strtolower($this->tabname)=='calendar'||strtolower($this->tabname)=='events')
        {
                 require_once(globalStatic::$root_directory .'modules/Calendar/Activity.php');
                $mainFocus=new Activity();
        }
        else
        {
            require_once(globalStatic::$root_directory .'modules/'.$this->tabname.'/'.$this->tabname.'.php');
             $mainFocus=new $this->tabname;
        }
     
       $strProductHtml=array();//存储产品打印的单元格，每一个单元个代表一个数组下标
       $strExpenseHtml=array();//存储费用报销打印的单元格，每一个单元个代表一个数组下标
	   $strCommissionHtml=array();//存储佣金单打印的单元格，每一个单元个代表一个数组下标
       $strDetailHtml=array();
       $bolProduct=false;//如果有产品明细打印则为true
       $bolExpense=false;//如果有费用报销明细打印则为true
	   $bolCommission=false;//如果有佣金单明细打印则为true
       $boldetailPrint=false;//带明细的模块打印
       $bolApprove=false;
	   global $bolBomPrint;
	   $bolBomPrint = false;//是否是产品套餐打印
	   $bolbomhtml = '';
	
       $printresult=$this->adb->pquery($printSQL,array());
        $line="";
        $sysdeploy = getSys_deploy(49);//数量
		if(isset($sysdeploy['deploy_value']))
			$lengthdecimaldigits = $sysdeploy['deploy_value'];
		else
			$lengthdecimaldigits  = 2;
		$sysdeploy_93 = getSys_deploy(93);//单价
        /**
        20141225
        andrew
        打印页面创建后更新合同订单打印状态
        */
        if($this->tabname=='SalesOrder'&&file_exists(globalStatic::$root_directory.'templatePrintFile/'.$this->printfilename)){
            $updatePrintSQL = "UPDATE ld_salesorder SET print='已打印' WHERE salesorderid=?";
            $this->adb->pquery($updatePrintSQL,array($this->recordid));
        }
         while (!feof($file_handle))
          {
                 $fieldname='';
                 if(strpos(strtolower($line),'<td')>0)
                    $prevtdline=$line;
                    
                $line = fgets($file_handle);
             
               
                $printcolumns=$this->getPrintColumnInfo($line);
               	//明细打印
                if((strpos(strtolower($line),'</table')>0||(strpos(strtolower($line),'tr>')>0))&&$boldetailPrint==true){
					$lasttrindex=strrpos(strtolower($printhtml),'<tr');
					$detailprinttd=substr($printhtml,$lasttrindex);
                    crm_load_class_file('cls_printDetail','include/TemplatePrint');
                    $printdetailobj=new cls_printDetail($this->focus,$this->recordid);
                    
					$printhtml=substr($printhtml,0,$lasttrindex);
					$detailprintresult=$printdetailobj->createDetailPrintResult();
					$styledetailtd=explode('<td',strtolower($detailprinttd));
				     $detailtable_Suffix=strtolower($this->focus->module_name).'details';//明细表后缀名称

					for($detailmoduleprint=0;$detailmoduleprint<$this->adb->num_rows($detailprintresult);$detailmoduleprint++){

						if(strpos(strtolower($styledetailtd[0]),'tr>')<=0){
							$styletd=0;
						}else{
							$styletd=1;
						}
                        $printhtml.='<tr>';
                        
                        for($tdi=0;$tdi<count($strDetailHtml);$tdi++){
							$firstindex=strpos(strtolower(trim(($strDetailHtml[$tdi]))),$detailtable_Suffix.'_')+strlen($detailtable_Suffix.'_');
							$lasttrindex=strrpos(strtolower(trim(($strDetailHtml[$tdi]))),'_'.strtolower($this->focus->module_name));
						
							$fieldname=substr(trim(($strDetailHtml[$tdi])),$firstindex,$lasttrindex-$firstindex);
							$prevtdhtml=substr(trim(($strDetailHtml[$tdi])),0,$firstindex-19);
							$curtabname=$this->focus->module_name;
							//echo $strCommissionHtml[$tdi] . '--';echo '<br><br>';
                            
							$fieldnames=explode('#_'.strtolower($this->focus->module_name).']',$fieldname);


                            if(sizeof($fieldnames)>1||stripos($fieldname,'#')===false){
        							if(stripos($fieldname,'_') > -1){
        								$fieldname = str_replace(array("\r\n", "\r", "\n"), '', $fieldname);
        								$fieldarr = explode('_',$fieldname);
                                       
                                        if(stripos($fieldarr[count($fieldarr)-2],strtolower($this->focus->module_name).'details')===false)
                                        {
                                            //due_date，source_total
                                            $tmp_arr=[];
                                            for($tmpi=2;$tmpi<sizeof($fieldarr);$tmpi++)
                                            {
                                                $tmp_arr[]=$fieldarr[$tmpi];
                                            }
                                            $fieldname =implode("_",$tmp_arr);// $fieldarr[count($fieldarr)-2]."_". $fieldarr[count($fieldarr)-1];
                                        }
                                        else
        								$fieldname = $fieldarr[count($fieldarr)-1];
        							}
                                   if(sizeof($fieldnames)>1&&stripos($fieldnames[1],strtolower($this->focus->module_name).'details_')===false)
                                    {
                                        $fieldname = $fieldnames[1];
                                    }

                                   $lineitem_id=$this->adb->query_result($detailprintresult,$detailmoduleprint,'lineitem_id');
        							$pcolvalue=$this->adb->query_result($detailprintresult,$detailmoduleprint,strtolower($fieldname).'_'.strtolower($curtabname));
        							  $old_pcolvalue=$pcolvalue;
									$values= $printdetailobj->getDataFormat($fieldname,$detailprintresult,$pcolvalue,$detailmoduleprint);
                                     $pcolvalue=$values['value'];
                                     if(strtolower($fieldname)=='entitytypeid')
                                     {
                                        $pcolvalue=$values['value_name'];
                                     }
                                    if(strtolower($fieldname).'_'.strtolower($curtabname) == 'isamount_'.strtolower($this->focus->module_name)){
        								$pcolvalue = $this->getDetailSourceHaveTotal($pcolvalue);
        							}
        							else if(strtolower($fieldname).'_'.strtolower($curtabname) == 'total_'.strtolower($this->focus->module_name)||strtolower($fieldname).'_'.strtolower($curtabname) == 'isamount_commission'||strtolower($fieldname).'_'.strtolower($curtabname) == 'invoicetotal_commission'||strtolower($fieldname).'_'.strtolower($curtabname) == 'subtotal_commission'){
        								$pcolvalue = number_format($pcolvalue,2);
        							}
                                    else if(strtolower($fieldname)=='entitytype')
                                    {
                                        $entitytype=($this->adb->query_result($detailprintresult,$detailmoduleprint,'entitytype'));
                                       
                                        $pcolvalue=getTranstab($entitytype);
                                    }
                                    else
                                    {
                                         
                                        $sql='select fieldtype,bigtype,referencemodule,savedatabase,columnname from ld_tabdetailfield where tabid=? and columnname=?';
                                        $fieldtype_result=$this->adb->pquery($sql,array($this->tabid,$fieldname));
                                        $fieldtype=$this->adb->query_result($fieldtype_result,0,0);
										$referencemodule=$this->adb->query_result($fieldtype_result,0,'referencemodule');
										$bigtype=$this->adb->query_result($fieldtype_result,0,'bigtype');
										$savedatabase=$this->adb->query_result($fieldtype_result,0,'savedatabase');
                                        $columnname=$this->adb->query_result($fieldtype_result,0,'columnname');
                                        //引用字段
										if($bigtype == 'relatedmodulefield' && $savedatabase == 'no'){
											$relatedmodulefield_sql = "select trigger_columnname from ld_related_detailfield where effect_columnname = ? and modulename = ? limit 1";
											$relatedmodulefield_result = $this->adb->pquery($relatedmodulefield_sql,array($fieldname,$this->tabname));
											$num_rows = $this->adb->num_rows($relatedmodulefield_result);
											if($num_rows >= 1){
												$trigger_columnname = $this->adb->query_result($relatedmodulefield_result,0,'trigger_columnname');
												$trigger_columnname_value=$this->adb->query_result($detailprintresult,$producti,$trigger_columnname.'_'.strtolower($curtabname));
												crm_load_class_file('cls_RelatedEntryField_Data','include/RelatedField');
												$_REQUEST['param'] = ldcrm_json_encode(array($trigger_columnname=>$trigger_columnname_value));
												$cls_RelatedEntryField_Data = new cls_RelatedEntryField_Data($this->tabname,$fieldname);
												$relatedmodulefield_data = $cls_RelatedEntryField_Data->getDataForColumn();
												if(!empty($relatedmodulefield_data)){
													$pcolvalue = $relatedmodulefield_data[$fieldname];
												}
											}
										}
										if(strtolower($fieldtype)=='date_ymd')
										{
											if($pcolvalue=='0000-00-00'||$pcolvalue<'1600-01-01')
											{
												$pcolvalue='';
											}
										}
										//关联选择单据
										if($bigtype == 'reference'){
										 
											if(!empty($pcolvalue)){
										      if($referencemodule=='Users')
                                                $pcolvalue=$old_pcolvalue;
                                           
												$pcolvalue = getModuleHref($referencemodule,$old_pcolvalue);
											}else{
												$pcolvalue = '';
											}
										}
										elseif (strtolower($fieldtype)=='image') {
                                            //ls 2022-06-13 【ID1002721】单据分录定制，增加“图片”字段类型【非产品分录图片字段打印】
                                            $pcolvalue = $this->getImageListPrint($columnname,$lineitem_id);
                                        }
                                         
                                    }
                                    
                                    
                                    if($pcolvalue==""){
                                        $pcolvalue=$this->replacespacevalue;
                                    }
                            }
                            else
                            {
                                $pcolvalue=$detailmoduleprint+1;
                            }
							if(strpos(strtolower($styledetailtd[$styletd]),'</td>')<=0){
								$printhtml.='<td '.$styledetailtd[$styletd].$pcolvalue.'</td>';
							}else{
								$stylestr=substr($styledetailtd[$styletd],0,strpos(strtolower($styledetailtd[$styletd]),'</td>'));
								$printhtml.='<td '.$stylestr.$pcolvalue.'</td>';
							}

							$styletd++;
                       }
                       $printhtml.='</tr>';
                    }
                    $line=substr($line,strpos($line,'</tr>')+5);
					$boldetailPrint=false;
					$strDetailHtml = array();
                }
              
				//佣金单打印
                if((strpos(strtolower($line),'</table')>0||(strpos(strtolower($line),'tr>')>0))&&$bolCommission==true){
					$lasttrindex=strrpos(strtolower($printhtml),'<tr');
					$commissiontd=substr($printhtml,$lasttrindex);
					$printhtml=substr($printhtml,0,$lasttrindex);
					$commissionresult=$this->createCommissionResult();
					$stylecommissiontd=explode('<td',strtolower($commissiontd));
				  
					for($commission=0;$commission<$this->adb->num_rows($commissionresult);$commission++){
                       
						if(strpos(strtolower($stylecommissiontd[0]),'tr>')<=0){
							$styletd=0;
						}else{
							$styletd=1;
						}
                        $printhtml.='<tr>';
                        for($tdi=0;$tdi<count($strCommissionHtml);$tdi++){
							$firstindex=strpos(strtolower(trim($strCommissionHtml[$tdi])),'commission2payment_')+19;
							$lasttrindex=strrpos(strtolower(trim($strCommissionHtml[$tdi])),'_commission');
							
							$fieldname=substr(trim($strCommissionHtml[$tdi]),$firstindex,$lasttrindex-$firstindex);
						
							$prevtdhtml=substr(trim($strCommissionHtml[$tdi]),0,$firstindex-19);
							$curtabname='Commission';
							//echo $strCommissionHtml[$tdi] . '--';echo '<br><br>';
							$fieldnames=explode('#_commission]',$fieldname);
                            if(sizeof($fieldnames)>1||stripos($fieldname,'#')===false){
        							if(stripos($fieldname,'_') > -1){
        								$fieldname = str_replace(array("\r\n", "\r", "\n"), '', $fieldname);
        							
										$fieldarr = explode('commissiondetails_',$fieldname);
									   //edit:can 20210421 45567: 诺达净化（http://snorda.9966.org:888/crm [^]）佣金单-默认打印模板：异常，字段取值丢失，但是模板设置的应该是没问题的（详情见附件）
										$fieldname = $fieldarr[sizeof($fieldarr)-1];
        							}
                                   
                                     if(sizeof($fieldnames)>1&&stripos($fieldnames[1],'commissiondetails_')===false)
                                        {
                                            $fieldname = $fieldnames[szieof($fieldnames)-1];
                                        }
        							$pcolvalue=$this->adb->query_result($commissionresult,$commission,strtolower($fieldname).'_'.strtolower($curtabname));
        							if(strtolower($fieldname).'_'.strtolower($curtabname) == 'isamount_commission'){
        								$pcolvalue = $this->getDetailSourceHaveTotal($pcolvalue);
        							}
        							else if(strtolower($fieldname).'_'.strtolower($curtabname) == 'total_commission'||strtolower($fieldname).'_'.strtolower($curtabname) == 'isamount_commission'||strtolower($fieldname).'_'.strtolower($curtabname) == 'invoicetotal_commission'||strtolower($fieldname).'_'.strtolower($curtabname) == 'subtotal_commission'){
        								$pcolvalue = number_format($pcolvalue,2);
        							}
                                    else if(strtolower($fieldname)=='entitytype')
                                    {
                                        $entitytype=($this->adb->query_result($commissionresult,$commission,'entitytype'));
                                       
                                        $pcolvalue=getTranstab($entitytype);
                                    }
                                    else
                                    {
                                        $sql='select fieldtype,bigtype,referencemodule,savedatabase from ld_tabdetailfield where tabid=? and columnname=?';
                                        $fieldtype_result=$this->adb->pquery($sql,array($this->tabid,$fieldname));
                                        $fieldtype=$this->adb->query_result($fieldtype_result,0,0);
										$referencemodule=$this->adb->query_result($fieldtype_result,0,'referencemodule');
										$bigtype=$this->adb->query_result($fieldtype_result,0,'bigtype');
										$savedatabase=$this->adb->query_result($fieldtype_result,0,'savedatabase');
										//引用字段
										if($bigtype == 'relatedmodulefield' && $savedatabase == 'no'){
											$relatedmodulefield_sql = "select trigger_columnname from ld_related_detailfield where effect_columnname = ? and modulename = ? limit 1";
											$relatedmodulefield_result = $this->adb->pquery($relatedmodulefield_sql,array($fieldname,$this->tabname));
											$num_rows = $this->adb->num_rows($relatedmodulefield_result);
											if($num_rows >= 1){
												$trigger_columnname = $this->adb->query_result($relatedmodulefield_result,0,'trigger_columnname');
												$trigger_columnname_value=$this->adb->query_result($commissionresult,$producti,$trigger_columnname.'_'.strtolower($curtabname));
												crm_load_class_file('cls_RelatedEntryField_Data','include/RelatedField');
												$_REQUEST['param'] = ldcrm_json_encode(array($trigger_columnname=>$trigger_columnname_value));
												$cls_RelatedEntryField_Data = new cls_RelatedEntryField_Data($this->tabname,$fieldname);
												$relatedmodulefield_data = $cls_RelatedEntryField_Data->getDataForColumn();
												if(!empty($relatedmodulefield_data)){
													$pcolvalue = $relatedmodulefield_data[$fieldname];
												}
											}
										}
                                         if(strtolower($fieldtype)=='amount')
										{
											$pcolvalue=setNumberFormat($pcolvalue);
										}
                                        else if(strtolower($fieldtype)=='price')
                                        {
                                            $pcolvalue=number_format($pcolvalue,$sysdeploy_93['deploy_value']);
                                        }
                                        else if(strtolower($fieldtype)=='number')
                                        {
                                            $pcolvalue=number_format($pcolvalue,$sysdeploy['deploy_value']);
                                        }
										else if(strtolower($fieldtype)=='date_ymd')
										{
											if($pcolvalue=='0000-00-00'||$pcolvalue<'1600-01-01')
											{
												$pcolvalue='';
											}
										}
										//关联选择单据
										if($bigtype == 'reference'){
											if(!empty($pcolvalue)){
												$entitytype = getSalesEntityType($pcolvalue);
												$pcolvalue = getModuleHref($referencemodule,$pcolvalue);
											}else{
												$pcolvalue = '';
											}
										}
                                         
                                    }
                                    
                                    
                                    if($pcolvalue==""){
                                        $pcolvalue=$this->replacespacevalue;
                                    }
                            }
                            else
                            {
                                $pcolvalue=$commission+1;
                            }
							if(strpos(strtolower($stylecommissiontd[$styletd]),'</td>')<=0){
								$printhtml.='<td '.$stylecommissiontd[$styletd].$pcolvalue.'</td>';
							}else{
								$stylestr=substr($stylecommissiontd[$styletd],0,strpos(strtolower($stylecommissiontd[$styletd]),'</td>'));
								$printhtml.='<td '.$stylestr.$pcolvalue.'</td>';
							}

							$styletd++;
                       }
                       $printhtml.='</tr>';
                    }
                    $line=substr($line,strpos($line,'</tr>')+5);
					$bolCommission=false;
					$strCommissionHtml = array();
                }
              
                //费用报销打印
				 if((strpos(strtolower($line),'</table')>0||(strpos(strtolower($line),'tr>')>0))&&$bolExpense==true){
					$lasttrindex=strrpos(strtolower($printhtml),'<tr');
					$expensetd=substr($printhtml,$lasttrindex);
					$printhtml=substr($printhtml,0,$lasttrindex);
					$expenseresult=$this->createExpenseResult();
					$styleexpensetd=explode('<td',strtolower($expensetd));

					for($expensei=0;$expensei<$this->adb->num_rows($expenseresult);$expensei++){

						if(strpos(strtolower($styleexpensetd[0]),'tr>')<=0){
							$styletd=0;
						}
						else{
							$styletd=1;
						}
						$printhtml.='<tr>';
						$total=$this->adb->query_result($expenseresult,$expensei,'money');
						$this->expenseTotal+=$total;//总价（净价）合计
                        for($tdi=0;$tdi<count($strExpenseHtml);$tdi++){
							$firstindex=strpos(strtolower(trim($strExpenseHtml[$tdi])),'expensedetails_')+15;//15:表示'expensedetails_'的长度
							$lasttrindex=strrpos(strtolower(trim($strExpenseHtml[$tdi])),'_expense');
							$fieldname=substr(trim($strExpenseHtml[$tdi]),$firstindex,$lasttrindex-$firstindex);
							$prevtdhtml=substr(trim($strExpenseHtml[$tdi]),0,$firstindex-15);
							$curtabname='Expense';
                              
							$fieldnames=explode('#_expense]',$fieldname);
							if(sizeof($fieldnames)>1||stripos($fieldname,'#')===false){//17002: 打印模板>费用报销,关于费用报销模块打印模板的问题
								/**
								* 施明诚所提奥特林豪斯打印模板问题
								* fieldname字段截取不正确，做一些特别处理
								* @author Tujt 2015-04-08
								*/
                                   
								if(stripos($fieldname,'_') > -1){
									$fieldname = str_replace(array("\r\n", "\r", "\n"), '', $fieldname);
									$fieldarr = explode('expensedetails_',$fieldname);
									
									$fieldname = $fieldarr[1];
                                 
								}
                                if(sizeof($fieldnames)>1&&stripos($fieldnames[1],'expensedetails_')===false)
                                {
                                    $fieldname = $fieldnames[1];
                                }

								$pcolvalue=$this->adb->query_result($expenseresult,$expensei,strtolower($fieldname).'_'.strtolower($curtabname));
                                 if($fieldname=='entitytypeid')
                                 {
                                     $entitytype=getSalesEntityType($pcolvalue);
                                     $entitynames=getEntitynameByModulename($entitytype);
                                     $field_href_name=$entitynames['fieldname'];
                                     $tablename=$entitynames['tablename'];
                                     $entity_fieldid=$entitynames['entityidfield'];
                                    if(!empty($pcolvalue))
                                    {
                                         $sql="select $field_href_name  from $tablename  where $entity_fieldid =$pcolvalue";
                                    
                                         $origin_result=$this->adb->pquery($sql,array());
                                         if($this->adb->num_rows($origin_result)>0)
                                         {
                                            $pcolvalue=$this->adb->query_result($origin_result,0,0);
                                         }
                                         else
                                         {
                                            $pcolvalue='';
                                         }
                                    }
                                     else
                                     {
                                        $pcolvalue='';
                                     }
                                    
                                     
                                 }
                                  else if(strtolower($fieldname)=='entitytype')
                                    {
                                        
                                        $entitytype=($this->adb->query_result($expenseresult,$expensei,'entitytype'));
                                       
                                        $pcolvalue=getTranstab($entitytype);
                                    }
                                 else
                                 {
                                        $sql='select fieldtype,bigtype,referencemodule,savedatabase,typeofdata from ld_tabdetailfield where tabid=? and columnname=?';
                                        $fieldtype_result=$this->adb->pquery($sql,array($this->tabid,$fieldname));
                                        $fieldtype=$this->adb->query_result($fieldtype_result,0,0);
                                       
										$referencemodule=$this->adb->query_result($fieldtype_result,0,'referencemodule');
										$bigtype=$this->adb->query_result($fieldtype_result,0,'bigtype');
										$savedatabase=$this->adb->query_result($fieldtype_result,0,'savedatabase');
                                        $stypeofdata = $this->adb->query_result($fieldtype_result,0,'typeofdata');
                                        $typeofdata = explode('~', $stypeofdata);
										//引用字段
										if($bigtype == 'relatedmodulefield' && $savedatabase == 'no'){
											$relatedmodulefield_sql = "select trigger_columnname from ld_related_detailfield where effect_columnname = ? and modulename = ? limit 1";
											$relatedmodulefield_result = $this->adb->pquery($relatedmodulefield_sql,array($fieldname,$this->tabname));
											$num_rows = $this->adb->num_rows($relatedmodulefield_result);
											if($num_rows >= 1){
												$trigger_columnname = $this->adb->query_result($relatedmodulefield_result,0,'trigger_columnname');
												$trigger_columnname_value=$this->adb->query_result($expenseresult,$expensei,$trigger_columnname.'_'.strtolower($curtabname));
												crm_load_class_file('cls_RelatedEntryField_Data','include/RelatedField');
												$_REQUEST['param'] = ldcrm_json_encode(array($trigger_columnname=>$trigger_columnname_value));
												$cls_RelatedEntryField_Data = new cls_RelatedEntryField_Data($this->tabname,$fieldname);
												$relatedmodulefield_data = $cls_RelatedEntryField_Data->getDataForColumn();
												if(!empty($relatedmodulefield_data)){
													$pcolvalue = $relatedmodulefield_data[$fieldname];
												}
											}
										}
                                        if(strtolower($fieldtype)=='amount' || strtolower($fieldtype)=='rmb_amount')
                                        {
                                            $pcolvalue=setNumberFormat($pcolvalue);
                                        }
                                        else if(strtolower($fieldtype)=='date_ymd')
                                        {
                                                if($pcolvalue=='0000-00-00'||$pcolvalue<'1600-01-01')
                                                {
                                                    $pcolvalue='';
                                                }
                                        }
                                         
                                        else if(strtolower($fieldtype)=='price')
                                        {
                                            $pcolvalue=number_format($pcolvalue,$sysdeploy_93['deploy_value']);
                                        }
                                        /*else if(strtolower($fieldtype)=='number')
                                        {
                                            $pcolvalue=number_format($pcolvalue,$sysdeploy['deploy_value']);
                                        }*/
                                     //2022-06-27 BUG0053035 费用报销单模块的打印模板，字段类型是数字类型的，显示的小数位点是一位，打印出来是8个小数点
                                     elseif(($typeofdata[0] == 'N' || $typeofdata[0] == 'NN')){
                                         if(is_numeric($pcolvalue)){
                                             if(strtolower($fieldtype)=='num'){//数字类型
                                                 $lengthdecimal = substr($typeofdata[2],strpos($typeofdata[2],',')+1);
                                                 $pcolvalue = setNumberFormat($pcolvalue,$lengthdecimal);
                                             }
                                         }
                                     }
										//关联选择单据
										if($bigtype == 'reference'){
											if(!empty($pcolvalue)){
												$entitytype = getSalesEntityType($pcolvalue);
												$pcolvalue = getModuleHref($referencemodule,$pcolvalue);
											}else{
												$pcolvalue = '';
											}
										}
                                 }
                        	}else
                            {
								$pcolvalue=$expensei+1;
							}
							if($pcolvalue==""){
								$pcolvalue=$this->replacespacevalue;
							}
							if(strpos(strtolower($styleexpensetd[$styletd]),'</td>')<=0){
								$printhtml.='<td '.$styleexpensetd[$styletd].$pcolvalue.'</td>';
							}else{
								$stylestr=substr($styleexpensetd[$styletd],0,strpos(strtolower($styleexpensetd[$styletd]),'</td>'));
								$printhtml.='<td '.$stylestr.$pcolvalue.'</td>';
							}
							$styletd++;
                       }
                       $printhtml.='</tr>';
                      
                    }
                    $line=substr($line,strpos($line,'</tr>')+5);
                    $bolExpense=false;
                    $strExpenseHtml=array();
                }

                //审批历史打印
                if((strpos(strtolower($line),'</table')>0||(strpos(strtolower($line),'tr>')>0))&&$bolApprove==true)
                {
                    $lasttrindex=strrpos(strtolower($printhtml),'<tr');
                    $approvetd=substr($printhtml,$lasttrindex);
                    $printhtml=substr($printhtml,0,$lasttrindex);
                   
                      require_once(globalStatic::$root_directory.'modules/Approve/Approve.php');
      
                    $approve = new Approve();
            		$approvemod = $approve->getApproveModuleInfo();
            	    $approvehtml='';
            		$approvelog = $approve->approveLog($this->recordid);
              
                   $styleapprovetd=explode('<td',strtolower($approvetd));
                   
                   $styleapprovetd=explode('<td',strtolower($approvetd));
                   $approvecount=sizeof($approvelog);
                   for($approvei=0;$approvei<sizeof($approvelog);$approvei++)
                    {
                       
                       foreach($approvelog[$approvei]['stepinfo'] as $stepinfo)
                       {
                            $styletd=1;
    
                            $printhtml.='<tr>';
                           
                            for($tdi=0;$tdi<count($strApproveHtml);$tdi++)
                            {
                              
                                  $firstindex=strpos(strtolower(trim($strApproveHtml[$tdi])),'approvedetails_')+15;//15:表示'approvedetails_'的长度
                                  $lasttrindex=strrpos(strtolower(trim($strApproveHtml[$tdi])),'_approve');
                                  $fieldname=substr(trim($strApproveHtml[$tdi]),$firstindex,$lasttrindex-$firstindex);
                                  $prevtdhtml=substr(trim($strApproveHtml[$tdi]),0,$firstindex-15);
                                  $curtabname='Approve';
                                  $fieldnames=explode('#_approve]',$fieldname);
                                  if(sizeof($fieldnames)>1||stripos($fieldname,'#')===false)
                                  {
    								  if(stripos($fieldname,'_') > -1){
    									  $fieldname = str_replace(array("\r\n", "\r", "\n"), '', $fieldname);
    									  $fieldarr = explode('_',$fieldname);
    									  $fieldname = $fieldarr[count($fieldarr)-1];
    								  }
                                     
                                      $pcolvalue=$stepinfo[strtoupper($fieldname)];
                                  }
                                  else 
                                  {
                                    
                                    $pcolvalue=$approvecount;
                                    $approvecount--;
                                  }
                                if($pcolvalue=="")
                                {
                                    $pcolvalue=$this->replacespacevalue;
                                }
                                //@edit:liushuai,2020-8-10,reason:1000994/打印模板定制审批历史中增加“手写签名”变量
                                //判断手写签名是否开启
                                global $global_regop;
                                if(!isset($global_regop))
                                    $global_regop=RegOp::getInstance();
                                $autograph = $global_regop->gethandleWriteSign_interface();
                                if ($autograph == 1) {
                                    //判断是否为图片非文本
                                    $file_suffix = pathinfo($pcolvalue,PATHINFO_EXTENSION);
                                    if (in_array($file_suffix,['jpg','png','gif'])) {
                                        $pcolvalue = '<img style="width:100px;height:200px;" border=0 src="'.$pcolvalue.'">';
                                    }
                                }
                               if(strpos(strtolower($styleapprovetd[$styletd]),'</td>')<=0)
                                   {
                                     $printhtml.='<td '.$styleapprovetd[$styletd].$pcolvalue.'</td>';
    
                                   }
                                  else
                                  {
                                      $stylestr=substr($styleapprovetd[$styletd],0,strpos(strtolower($styleapprovetd[$styletd]),'</td>'));
                                      
                                      $printhtml.='<td '.$stylestr.$pcolvalue.'</td>';
                                  }
                                  
                                 $styletd++;
                           }
                           $printhtml.='</tr>';
                       }
                       
                      
                    }
                    $line=substr($line,strpos($line,'</tr>')+5);
                    $bolApprove=false;
                    $strApproveHtml=array();
                }
               
                
                //处理产品的html
                if((strpos(strtolower($line),'</table')>0||(strpos(strtolower($line),'tr>')>0))&&$bolProduct==true)
                {

                    $lasttrindex=strrpos(strtolower($printhtml),'<tr');
                  $producttd=substr($printhtml,$lasttrindex);
                  $printhtml=substr($printhtml,0,$lasttrindex);
                
                   $productresult=$this->createProductResult();
				   $producttd_arr = explode('>',$producttd);
				   //chj 2021/8/9 47375: （http://2x1z518882.qicp.vip/crm [^]）客户问题（明思克）库存管理->出库单，出库单编号：CK13401，单据详情->更多->打印工具->打印，单据分录的“合同信息”字段的H在打印模版上显示h。
					if(sizeOf($producttd_arr) >= 1)
						$styleproducttd=explode('<td',$producttd);
					else
						$styleproducttd=explode('<td',strtolower($producttd));
                   $productrows = $this->adb->num_rows($productresult);
       
                    for($producti=0;$producti<$productrows;$producti++)
                    {
                      
                       
                       if(strpos(strtolower($styleproducttd[0]),'tr>')<=0)
                       {
                            
                             $styletd=0;
                        }
                        else
                        {
                            $styletd=1;
                        }
                        $printhtml.='<tr>';
                         $discount_percent=$this->adb->query_result($productresult,$producti,'discount_percent_products');//折扣 
                         $discount_amount=$this->adb->query_result($productresult,$producti,'discount_amount_products');//直接降价
                         $quantity=$this->adb->query_result($productresult,$producti,'quantity_products');//数量
                         $listprice=$this->adb->query_result($productresult,$producti,'listprice_products');//单价
                         $productid=$this->adb->query_result($productresult,$producti,'productid');
                         $lineitem_id=$this->adb->query_result($productresult,$producti,'lineitem_id');

                        $taxtype=$this->adb->query_result($productresult,$producti,'hdntaxtype_salesorder');
                         $total=$listprice*$quantity;//净价
                         $RealDiscount=0;
                         $totalMoney=$total;
                         if(!empty($discount_percent)&&isset($discount_percent))
                         {
                            $RealDiscount=$total*$discount_percent/100;//折扣额       
                            $total=$total-$total*$discount_percent/100;        
                         }
                         if(!empty($discount_amount)&&isset($discount_amount))
                         {
                            $total-=$discount_amount;
                            $RealDiscount=$discount_amount;//折扣额
                                    
                         }
                     
                       $totalAfterDiscount=$total;
                       $taxtotal=0;
            		  if($taxtype=='单独')
                      {
                            $tax_details = getTaxDetailsForProduct($productid, 'all');
                			for ($tax_count = 0; $tax_count < count($tax_details); $tax_count++) {
                				$tax_name = $tax_details[$tax_count]['taxname'];
                				$tax_label = $tax_details[$tax_count]['taxlabel'];
                                $query = 'select '.$tax_name." from $detailtable where id = ? and productid = ? ";
                            
                            	$res = $this->adb->pquery($query, array($this->recordid, $productid));
                            	$rows = $this->adb->num_rows($res);
                            	$taxvalue = '';
                            	if($rows > 0){
                            		$taxvalue = $this->adb->query_result($res,0,$tax_name);
                            	}
                            	if($taxvalue == '')
                            		$taxvalue = '0.00';
                			
                				$individual_taxamount = $totalAfterDiscount * $taxvalue / 100;
                				$individual_taxamount = number_format($individual_taxamount, 2,'.',''); //Convert to 2 decimals
                				$taxtotal = $taxtotal + $individual_taxamount;
                				$taxtotal = number_format($taxtotal, 2,'.',''); //Convert to 2 decimals
                			
                			}
                            
                            $total+=$taxtotal;
                      }
                    	
                       $sysdeploy_93 = getSys_deploy(93);
                       $sysdeploy_93 = $sysdeploy_93['deploy_value'];
                       $this->productTotal+=$total;//总价（净价）合计
					   $sreproductcount =	count($strProductHtml);//$strProductHtml
				   
                       for($tdi=0;$tdi<$sreproductcount;$tdi++)
                       {
						   $strProductHtml[$tdi] = trim(strtolower($strProductHtml[$tdi]));
                       
						   $pos = strrpos($strProductHtml[$tdi],'productdetails_');
						   /**
						    * 支持产品列表出现如合同订单编号之类的列，
							* 增加判断是否为产品字段判断语句
						    * @author Tujt 2015-01-08
						    */
						   if($pos && $pos > -1){
								$lastproductdetailindex=strrpos($strProductHtml[$tdi],'productdetails_')+15;//15:表示'productdetails_'的长度
								$lasttrindex=strrpos($strProductHtml[$tdi],'_products');
						   }else{
								$strstr = explode('_',$strProductHtml[$tdi]);
								$lastproductdetailindex = count($strstr)+1;
								$lasttrindex = 0;
						   }
							  //echo $strProductHtml[$tdi].' -- '.$lastproductdetailindex.' -- '.($lasttrindex-$lastproductdetailindex);echo '<br><br>';
                              $fieldname=substr(trim($strProductHtml[$tdi]),$lastproductdetailindex,$lasttrindex-$lastproductdetailindex);
                              $prevtdhtml=substr(trim($strProductHtml[$tdi]),0,$lastproductdetailindex-15);
                              $curtabname='Products';
                            
                              if(strpos(strtolower($strProductHtml[$tdi]),'discounttotal_products')>0)//单行产品净价(合计)
                              {
                                 
                                  $pcolvalue=number_format($total,2);
                              }
                               else if(strpos(strtolower($strProductHtml[$tdi]),'_taxprice_products')>0)//单价
                              {
                                 
                                  $pcolvalue=number_format($this->adb->query_result($productresult,$producti,'taxprice_products'),$sysdeploy_93);
                              }
							  else if(strpos(strtolower($strProductHtml[$tdi]),'listprice_products')>0)//单价
                              {
                                 
                                  $pcolvalue=number_format($this->adb->query_result($productresult,$producti,'listprice_products'),$sysdeploy_93);
                              }
							   else if(strpos(strtolower($strProductHtml[$tdi]),'unit_price_products')>0)//单价
                              {
                                 
                                  $pcolvalue=number_format($this->adb->query_result($productresult,$producti,'unit_price_products'),$sysdeploy_93);	//参考价
                              }
                              else if(strpos(strtolower($strProductHtml[$tdi]),'tax_amount_products')>0)//价税合计
                              {
                                 
                                  $pcolvalue=number_format($this->adb->query_result($productresult,$producti,'tax_amount_products'),2);
                              }
                              else if(strpos(strtolower($strProductHtml[$tdi]),'costprice_products')>0)//参考成本价
                              {
                                  //ls 2022-02-24 0050124: 生产加工合同模板（模板名称：生产定作合同）中无法带出出厂价金额（模板中的单价（标准版本叫参考成本价）即为出厂价）
                                  $pcolvalue=number_format($this->adb->query_result($productresult,$producti,'procostprice_products'),$sysdeploy_93);
                              }
                              elseif(strpos(strtolower($strProductHtml[$tdi]),'realdiscount_products')>0)
                              {
                                $pcolvalue=$RealDiscount;
                              }
                              elseif(strpos(strtolower($strProductHtml[$tdi]),'#_products')>0&&trim($fieldname)=='#')
                              {
                                $pcolvalue=$producti+1;
                              }
                             /* elseif(strpos(strtolower($strProductHtml[$tdi]),'entitytype_products')>0)
                              {
                                 $pcolvalue=$this->adb->query_result($productresult,$producti,'entitysubject_products');
                              }*/
                              elseif(strpos(strtolower($strProductHtml[$tdi]),'mergerqty_unit_products')>0)
                              {
                                //数量单位  格式化为2位小数
                                 $pcolvalue=number_format($this->adb->query_result($productresult,$producti,'quantity_products'),2).$this->adb->query_result($productresult,$producti,'usageunit_products');
                              }
                              else if(strpos(strtolower($strProductHtml[$tdi]),'imagename_products')>0)//产品图片
                              {   
                                    $sizeimages=explode('imagename_products',$strProductHtml[$tdi]);
                                    
                                    if($sizeimages[1]!='')
                                    {
                                        $image_width=$sizeimages[$sizelen-2];
                                    }
                                   $productid=$this->adb->query_result($productresult,$producti,'productid');
                                   $query='
                                        SELECT  
                                            ld_attachments.path as product_image_path,storage_location,cloud_path,
                                            ld_attachments.attachmentsid as product_image_attachmentsid,
                                            ld_attachments.newfile_name as product_image_name,
                                            ld_products.productid as product_productid
                                        FROM ld_products
                                        LEFT JOIN ld_seattachmentsrel ON ld_seattachmentsrel.crmid = ld_products.productid
                                        INNER JOIN ld_attachments ON ld_attachments.attachmentsid = ld_seattachmentsrel.attachmentsid
                                        INNER JOIN ld_crmentity ON ld_crmentity.crmid = ld_attachments.attachmentsid 
                                        WHERE ld_crmentity.setype = "Products Image"   
                                            AND ld_products.productid='.$productid.' 
                                        ORDER BY ld_attachments.attachmentsid DESC LIMIT 1';
                                   $product_image_result=$this->adb->pquery($query,array());
                                   
                                   if($this->adb->num_rows($product_image_result)>0)
                                   {	
                                        $product_image_name = $this->adb->query_result($product_image_result,0,'product_image_name');
                                        $product_image_name = urlencode(decode_html( $product_image_name));
                                        $imagepath= $this->adb->query_result($product_image_result,0,'product_image_path') .$this->adb->query_result($product_image_result,0,'product_image_attachmentsid').'_'. $product_image_name;
                                        $storage_location=$this->adb->query_result($product_image_result,0,'storage_location');
                                        $cloud_path=$this->adb->query_result($product_image_result,0,'cloud_path');
                                        if($storage_location=='cos')
                                        {
                                            $imagepath=$cloud_path;
                                        }
                                        else if(!file_exists($imagepath))
                                        {
                                            $lastimg=explode('.',$product_image_name);
                                        
                                            $imagepath=$this->adb->query_result($product_image_result,0,'product_image_path') .$this->adb->query_result($product_image_result,0,'product_image_attachmentsid'). "_1.".$lastimg[sizeof($lastimg)-1];
                                            if(!file_exists($imagepath))
                                            {
                                                $arr=array("ASCII","UTF-8","GB2312","GBK",'BIG-5');
                                                $encode=mb_detect_encoding($product_image_name, $arr); 
                                                if($encode=='UTF-8')
                                                {
                                                    $imagepath=$this->adb->query_result($product_image_result,0,'product_image_path') . $product_image_name ;
                                                }
                                                else
                                                {
                                                    $imagepath=$this->adb->query_result($product_image_result,0,'product_image_path') . iconv('gb2312','utf-8',$product_image_name);
                                                }
                                            }
                                            
                                            if(!file_exists($imagepath))//
                                            {
                                                $arr=array("ASCII","UTF-8","GB2312","GBK",'BIG-5');
                                                $encode=mb_detect_encoding($product_image_name, $arr); 
                                                
                                                //Edit by luyx:2018-04-09
                                                //Title：图片路径为什么要加上id ？
                                                if($encode=='UTF-8')
                                                {   
                                                    $imagepath=$this->adb->query_result($product_image_result,0,'product_image_path').$product_image_name ;
                                                }
                                                else
                                                {
                                                    $imagepath=$this->adb->query_result($product_image_result,0,'product_image_path').iconv('gb2312','utf-8',$product_image_name) ;
                                                }
                                            }
                                        }
                                        
                                        //echo $imagepath . '<br>';


                                        //echo $imagepath;

//                                       @edit:liushuai,2021-02-18,reason:0044656: （http://realytech2021.gnway.vip:8000/crm [^]）（王杰）合同订单-打印工具-导出doc，添加的公司logo和电子签章没有显示。
                                       if($storage_location != 'cos')  //local or null
                                       {
                                           $url = curPageURL();
                                           if(!empty($_REQUEST['weixin_pdf']) && $_REQUEST['weixin_pdf'] == 'yes'){
                                               $site_url = explode('WeiXinApp',$url);
                                           }else{
                                               $site_url = explode('index.php',$url);
                                           }

                                           $imagepath = $site_url[0].$imagepath;  //打印导出为doc时，图片路径得是绝对路径
                                       }

                                				list($pro_image_width, $pro_image_height) = getimagesize($imagepath);
                                                $sysdeploy=getSys_deploy(75);
                                                $val=explode(',',$sysdeploy['deploy_value']);

												if($pro_image_width > 0 && $pro_image_width <= $val[0] && $pro_image_height>0 && $pro_image_height <= $val[1]){
													$pcolvalue= '<img src="' . $imagepath . '" border="0" width="' . $pro_image_width . '" height="' . $pro_image_height . '">';
												 }else{
													$pcolvalue= '<img src="' . $imagepath . '" border="0" width="' . $val[0] . '" height="' . $val[1] . '">';
												 }
                                				/*if ($pro_image_width > $image_width || $pro_image_height > $image_height)
                                					$pcolvalue = '<img src="' . $imagepath . '" border="0" width="'.$image_width.'" height="'.$image_height.'">';
                                				else
                                					$pcolvalue = '<img src="' . $imagepath . '" border="0" width="' . $pro_image_width . '" height="' . $pro_image_height . '">';*/
                                   }
                                   else
                                   {
                                    $pcolvalue='';
                                   }
                                   
                              }
                            
                              else
                              {
								
                                $pcolvalue=$this->adb->query_result($productresult,$producti,strtolower($fieldname).'_'.strtolower($curtabname));
                                 
                                //$sysdeploy = getSys_deploy(49);//数量小数位
								//$sysdeploy_93 = getSys_deploy(93);//单价
                                //0023826:（戚涛反馈）打印模板：“金额”字段，小数位显示根据系统参数“设置单据分录明细中数量字段小数位数”显示。应该是显示2位小数位。
                                $sql = 'select uitype,typeofdata,columnname,bigtype,referencemodule,savedatabase from ld_producttoolfield where columnname=? and tabid = ? limit 1';
                                $result = $this->adb->pquery($sql,array(strtolower($fieldname),$this->tabid));     
                               
                                if($this->adb->num_rows($result)>0)
                                {
									$stypeofdata = $this->adb->query_result($result,0,'typeofdata');
                                    $uitype=$this->adb->query_result($result,0,'uitype');
                                    $columnname=$this->adb->query_result($result,0,'columnname');
                                    $bigtype=$this->adb->query_result($result,0,'bigtype');
									$savedatabase=$this->adb->query_result($result,0,'savedatabase');
                                    $referencemodule=$this->adb->query_result($result,0,'referencemodule');
									$typeofdata = explode('~', $stypeofdata);
									//引用字段
									if($bigtype == 'relatedmodulefield' && $savedatabase == 'no'){
										$relatedmodulefield_sql = "select trigger_columnname from ld_related_detailfield where effect_columnname = ? and modulename = ? limit 1";
										$relatedmodulefield_result = $this->adb->pquery($relatedmodulefield_sql,array($columnname,$this->tabname));
										$num_rows = $this->adb->num_rows($relatedmodulefield_result);
										if($num_rows >= 1){
											$trigger_columnname = $this->adb->query_result($relatedmodulefield_result,0,'trigger_columnname');
											$trigger_columnname_value=$this->adb->query_result($productresult,$producti,$trigger_columnname.'_'.strtolower($curtabname));
											crm_load_class_file('cls_RelatedEntryField_Data','include/RelatedField');
											$_REQUEST['param'] = ldcrm_json_encode(array($trigger_columnname=>$trigger_columnname_value));
											$cls_RelatedEntryField_Data = new cls_RelatedEntryField_Data($this->tabname,$columnname);
											$relatedmodulefield_data = $cls_RelatedEntryField_Data->getDataForColumn();
											if(!empty($relatedmodulefield_data)){
												$pcolvalue = $relatedmodulefield_data[$columnname];
											}
										}
									}
									if(($typeofdata[0] == 'N' || $typeofdata[0] == 'NN')){
										if(strtolower($fieldname).'_'.strtolower($curtabname) == 'qtyinstock_products'){
											if(getTabModuleName($this->tabid) == 'Quotes' || getTabModuleName($this->tabid) == 'SalesOrder'){
												if($current_user->is_admin == 'off' && isset($current_user->column_fields['view_quantity']) && $current_user->column_fields['view_quantity'] == 0){
													if($pcolvalue >= 21){
														$pcolvalue = getFixedLabel('many');	//多
													}else if($pcolvalue <=20 && $pcolvalue > 0){
														$pcolvalue = getFixedLabel('less');	//少
													}else{
														$pcolvalue = getFixedLabel('NONE');	//无
													}
												}
											}
										}
										$uitype = $this->adb->query_result($result,0,'uitype');
                                      
										if(is_numeric($pcolvalue)){
											if($uitype  >= 10 && $uitype < 15){//数量小数位格式化,根据系统参数小数位控制
												$pcolvalue = setNumberFormat($pcolvalue,$lengthdecimaldigits);
											}
                                           
                                            elseif($uitype == 163){//单价
												$pcolvalue = setNumberFormat($pcolvalue,$sysdeploy_93['deploy_value']);
											}
                                            //zkt 20220402 50715: （http://xiaoshou360.com/xs/lkdk [^]）客户问题（立凯电子），报价单（报价单号：QUO202203281323），打印->导出成PDF格式时，“最小包装量”字段仍然显示小数位数（参数中已经设置不显示小数位数了）
                                            elseif($uitype == 20 || $uitype == 15 || $uitype==7){//小数位
												$lengthdecimal = substr($typeofdata[2],strpos($typeofdata[2],',')+1);
												$pcolvalue = setNumberFormat($pcolvalue,$lengthdecimal);
											}
                                           
                                            else if($uitype==24)//整数
                                            {
                                                //
                                                 // echo $pcolvalue.'waa';
                                            
                                            }
                                            else{
												$pcolvalue = setNumberFormat($pcolvalue,2);
											}
										}
									}
                                     else if($uitype==63)//多选框
                                     {
                                       
                                                $pcolvalue=implode(' ',explode("|##|",$pcolvalue));
                                     }
                                    else if($uitype==204)
                                    {
                                        $pcolvalue=getTranstab($pcolvalue);
                                    }
                                    else if($uitype==60&&$columnname=='wareid')
                                      {
                                        //出库单的仓库
                                        static $template_ware_id;
                                        if($template_ware_id[$pcolvalue])
                                        {
                                            $pcolvalue=$template_ware_id[$pcolvalue];
                                        }
                                        else
                                        {
                                                 $tmpsql='select name from ld_warehouse where id='.$pcolvalue;
                                                $wareresult=$this->adb->pquery($tmpsql);
                                                if($this->adb->num_rows($wareresult)>0)
                                                {
                                                    $template_ware_id[$pcolvalue]=$this->adb->query_result($wareresult,0,'name');
                                                    $pcolvalue=$this->adb->query_result($wareresult,0,'name');
                                                }
                                                else
                                                {
                                                    $pcolvalue='';
                                                }
                                        }
                                                
                                      }
									else if($uitype==56){
										if($pcolvalue == 1){
											$pcolvalue = getFixedLabel('YES');
										}else{
											$pcolvalue = getFixedLabel('NO');
										}
									}
                                    else if($uitype==69){
                                        //ls 2022-06-13 【ID1002721】单据分录定制，增加“图片”字段类型【产品分录图片字段打印，仅打印第一个】
                                        $pcolvalue = $this->getImageListPrint($columnname,$lineitem_id);

                                    }
                                    else if($uitype==200)
                                    {
                                        $sourcmodule=$this->adb->query_result($productresult,$producti,'entitytype');
                                        if(!empty($sourcmodule))
                                       {
                                         $entitynames= getEntitynameByModulename($sourcmodule);
                                           $source_focus=CRMEntity::getInstance($sourcmodule);
                                           $source_table=$entitynames['tablename'];
                                           $source_table_index=$source_focus->tab_name_index[$source_table];
                                           $source_columnname=$entitynames['fieldname'];
                                           $source_sql="select $source_columnname from  $source_table where $source_table_index=$pcolvalue";
                                           $source_result=$this->adb->pquery($source_sql,array());
                                           if($this->adb->num_rows($source_result)>0)
                                           {
                                                $pcolvalue=$this->adb->query_result($source_result,0,0);
                                           }
                                       }
                                      
                                       else
                                       {
                                            $pcolvalue='';
                                       }
                                    }
                                    else if($uitype==51)
                                    {
                                        if($pcolvalue<'1600-01-01')
                                        {
                                            //edit:can 2020-09-03 042576: （http://118.89.153.246:85/crm [^]）（客户问题：申贝科学仪器（苏州）有限公司）报价单模块明细界面>更多>打印：打印后“货期”字段内容显示不对。（需要补丁）
                                            $pcolvalue='';
                                        }
                                    }
                                    else if($uitype==205 ||$uitype==202)
                                    {
                                        if(!empty($pcolvalue))
                                        {
                                            $sourcmodule=getSalesEntityType($pcolvalue);
                                           $entitynames= getEntitynameByModulename($sourcmodule);
                                           $source_focus=CRMEntity::getInstance($sourcmodule);
                                           $source_table=$entitynames['tablename'];
                                           $source_table_index=$source_focus->tab_name_index[$source_table];
                                           $source_columnname=$entitynames['fieldname'];
                                           $source_sql="select $source_columnname from  $source_table where $source_table_index=$pcolvalue";
                                           $source_result=$this->adb->pquery($source_sql,array());
                                           if($this->adb->num_rows($source_result)>0)
                                           {
                                                $pcolvalue=$this->adb->query_result($source_result,0,0);
                                           }
                                        }
                                        else
                                        {
                                            $pcolvalue='';
                                        }
                                        
                                    }
									//关联选择单据
									if($bigtype == 'reference'){
										if(!empty($pcolvalue)){
											$entitytype = getSalesEntityType($pcolvalue);
											$pcolvalue = getModuleHref($referencemodule,$pcolvalue);
										}else{
											$pcolvalue = '';
										}
									}
                                }
                              }
                            
                            if($pcolvalue=='')
                            {
                                $pcolvalue=$this->replacespacevalue;
                            }
                          
							/**
							 * 支持产品行，空列字段
							 * @author Tujt 2015-01-08
							 */
							if('NULL' == $fieldname){
								$printhtml .= '<td>&nbsp;</td>';continue;
							}
                            $lineenter=explode('\r\n',$pcolvalue);//是否包含换行符
                           if(sizeof($lineenter))
                           {
                             $pcolvalue=str_replace("\n","<br>",$pcolvalue);
                           }
                         
                           if(strpos(strtolower($styleproducttd[$tdi+1]),'</td>')<=0)
                               {
                                 
                                 if($tdi==sizeof($styleproducttd)-1)
								  {
									  $printhtml.='<td '.$styleproducttd[$tdi].$pcolvalue.'</td>';
								  }
								  else
									$printhtml.='<td '.$styleproducttd[$tdi+1].$pcolvalue.'</td>';
                                 
                               }
                              else
                              {
                               
                                    $stylestr=substr($styleproducttd[$styletd],0,strpos(strtolower($styleproducttd[$styletd]),'</td>'));
                                     if(strpos($stylestr,'>')!==false)
                                        $printhtml.='<td '.$stylestr.$pcolvalue.'</td>';
                                     else
                                        $printhtml.='<td '.$styleproducttd[$styletd].$pcolvalue.'</td>';
                              }
                              
                             $styletd++;
                       }
					   if($bolBomPrint && !empty($bomprinthtml)){
						   if($productrows > 1){
							   $bomprinthtml = strtolower($bomprinthtml);
							   //$bomprinthtml = strtr($bomprinthtml,array('rowspan="4"','rowspan="6"'));
							   $bomrowspan = $productrows+3;
							   $bomprinthtml = str_replace('rowspan="4"','rowspan="'.$bomrowspan.'"',$bomprinthtml);
						   }
							$printhtml.= $bomprinthtml;
							$bomprinthtml = '';
					   }
                       $printhtml.='</tr>';
                      
                    }
                    $line=substr($line,strpos($line,'</tr>')+5);
                    $bolProduct=false;
                    $strProductHtml=array();
                }
           
                if(count($printcolumns)>0&&stripos($line,'var')!==false)//如果该行有[]
                {

                    $printcols=preg_split("/(\[Var.|\[var.|\[VAR.|\[vAR.|\[VAr.|\[VaR.|\[vaR.|\[vAr.)/",$line);
                    
                    for($i=0;$i<count($printcols);$i++)
                    { 
                     
                        $fieldname='';
                        if(strpos($printcols[$i],']')>0)//找到需要打印的列
                        {
                            $endcol=strpos($printcols[$i],']');
                            $colsinfo=substr($printcols[$i],0,$endcol);
                            $tabcols=explode('_',$colsinfo);


                            if(strtolower($tabcols[0])=='(function)')//条形码打印
                            {
                                         
                                        $printhtml.=$this->createBarCode($printcols[$i],$mainFocus).substr($printcols[$i],$endcol+1);
                                        continue;
                            }
                            else if(strtolower($colsinfo)=='table_today_table')
                            {
                                $printhtml.=date("Y-m-d").substr($printcols[$i],$endcol+1);
                                continue;
                            }
                            else if(strtolower($colsinfo)=='table_month_table')
                            {
                                $printhtml.=date("m").substr($printcols[$i],$endcol+1);
                                continue;
                            }
                            else if(strtolower($colsinfo)=='table_year_table')
                            {
                                $printhtml.=date("Y").substr($printcols[$i],$endcol+1);
                                continue;
                            }
                            //复地打印模版需求打印模板设置中增加一个变量用来打印回款计划对应的服务合同中产品的起始日期和截止日期
                            else if(strtolower($tabcols[0]) == 'serviceproduct' && strtolower($tabcols[1]) == 'serviceproductinfo'){
                
                                $printhtml .= $this->getServiceProductsInfo().substr($printcols[$i],$endcol+1);
                                continue;
                            }else if(strtolower($tabcols[0]) == 'productdetailscf'){
								$getProductcfValue = $this->getProductcfValue();
								if($tabcols[1] == 'taxprice'){
									$printhtml .= setNumberFormat($getProductcfValue[$tabcols[1]],$lengthdecimaldigits).substr($printcols[$i],$endcol+1);
								}else if($tabcols[1] == 'productname'){
									$printhtml .= $getProductcfValue[$tabcols[1]].substr($printcols[$i],$endcol+1);
								}else{
									$printhtml .= $getProductcfValue[$tabcols[2]].substr($printcols[$i],$endcol+1);
								}
                                
                                continue;
                            }else if(strtolower($tabcols[2]) == 'productrow'){
								$printhtml .= $this->getProductDetailValue($tabcols[1]).substr($printcols[$i],$endcol+1);
								continue;
							}else if(strtolower($tabcols[0]) == 'accountcontactdetails'){//获取客户首要联系人信息
								$accountcontact_info = $this->getAccountContactInfo();
								$printhtml .= $accountcontact_info[$fieldname].substr($printcols[$i],$endcol+1);
								
							}
                            //订单应收款
                            else if(strtolower($tabcols[0])=='order'&&strtolower($tabcols[1])=='getbillamount')
                             {
                                      
								  $printhtml.=$this->getBillAmount_ByOrder($mainFocus).substr($printcols[$i],$endcol+1);
								  continue;
                             }
							else if(strtolower($tabcols[0])=='commission'&&strtolower($tabcols[1])=='originbill'){
								$commission_entitytype = $this->getCommissionEntityType();
								if(!empty($commission_entitytype)){
									$printhtml.=getDetailListValName($this->recordid,$commission_entitytype,2).substr($printcols[$i],$endcol+1);
								}else{
									$printhtml.=substr($printcols[$i],$endcol+1);
								}
								continue;
							}else if(strtolower($tabcols[0])=='order'&&strtolower($tabcols[1])=='havereceivables')
                             {
                                      //订单已收款
                                      $printhtml.=$this->getBillAmount_ByOrder($mainFocus,'2').substr($printcols[$i],$endcol+1);
                                      continue;
                             }
                             //客户应收款
                            else if(strtolower($tabcols[0])=='accounts'&&strtolower($tabcols[1])=='getbillamount')
                            {
                                      $printhtml.=$this->getBillAmount_ByAccounts($mainFocus) .substr($printcols[$i],$endcol+1);
                                      continue;
                            }
                             else if(strtolower($tabcols[0])=='approvehistory'&&strtolower($tabcols[1])=='module')
                             {
                                $printhtml.=$this->getApproveHistory();
                                continue;
                             }
                              
                                $curtabname=$tabcols[count($tabcols)-1];//当前打印字段所在模块
                                $tabsql='select name from ld_tab where name=?'; //Can20170321,这块从数据库获取模块名称，因为在Linux服务器模块名称区分大小写，导致负责人手机字段打印不出
                                $tabresult=$this->adb->pquery($tabsql,array($curtabname));
                                if($this->adb->num_rows($tabresult)>0)
                                    $curtabname=$this->adb->query_result($tabresult,0,0);
                                //24115: （念空）管理费、管理费佣金：设置一个打印模版插入该模块的字段，打印不出来
                              
                                if(file_exists(globalStatic::$root_directory.'modules/'.$curtabname.'/'.$curtabname.'.php'))
                                {
                                    $cur_focus=CRMEntity::getInstance($curtabname);
                                   $count_strokes=explode("_",$cur_focus->table_name);
                                   $fi_start=sizeof($count_strokes)-1;//获取模块名称下划线个数
                                  
                                    for($fi=$fi_start ;$fi<count($tabcols)-1;$fi++)
                                    {
                                         if($fi!=(count($tabcols)-2))
                                             $fieldname.=$tabcols[$fi].'_';
                                        else
                                            $fieldname.=$tabcols[$fi];
                                    }
                                }else{
									$fieldname = $tabcols[1];
								}
                                
                               if((!array_key_exists(strtolower($curtabname),$relatedtabs)&&strtolower($curtabname)!='table')&&strtolower($tabcols[0])!='approvedetails')
                                {
                                    if(stripos($printcols[$i],'['))
                                    {
                                        $printhtml.=$printcols[$i];
                                    }
                                    else
                                    $printhtml.='[var.'.$printcols[$i];
                                    continue;
                                }  
                                 
                            if(count($tabcols)>0&&strlen($tabcols[1])>0&&strlen($tabcols[0])>0)
                            {  
                              
                                 
                                    if(strtolower($tabcols[0])=='table'&&strtolower($tabcols[1])=='today')
                                    {
                                        $printhtml.=date('Y-m-d').substr($printcols[$i],$endcol+1);
                                         continue;
                                    }  
                                    if(strtolower($tabcols[0])=='table' &&strtolower($tabcols[1])=='month')
                                    {
                                         $printhtml.=date('m').substr($printcols[$i],$endcol+1);
                                         continue;
                                    }  
                                    if(strtolower($tabcols[0])=='table' &&strtolower($tabcols[1])=='year')
                                    {
                                         $printhtml.=date('Y').substr($printcols[$i],$endcol+1);
                                         continue;
                                    }  
                                     if(strtolower($tabcols[0])=='table' &&strtolower($tabcols[1])=='day')
                                    {
                                         $printhtml.=date('d').substr($printcols[$i],$endcol+1);
                                         continue;
                                    }  
                                    //打印欠账或应收信息
                                    if(strtolower($tabcols[0])=='paymentplan'&&strtolower($tabcols[1])=='nocashbill')
                                    {
                                        $printhtml.=$this->createNoCashBill().substr($printcols[$i],$endcol+1);
                                        continue;
                                    }
                                    
                                    if(strtolower($tabcols[0])=='paymentplan'&&strtolower($tabcols[1])=='debitnote')
                                    {
                                        $printhtml.=$this->createDebitNote().substr($printcols[$i],$endcol+1);
                                        continue;
                                    }
                                    /*edit:can;date:20140111;reason:更多信息*/
                                    if(strtolower($tabcols[0])=='more'&&strtolower($tabcols[1])=='get')
                                    {
                                        if(!isset($templatemore))
                                            $templatemore=new TemplatePrintMoreInfo($this->tabname,$this->tabid,$this->recordid,$this->adb,$this->replacespacevalue);
                                        
                                        $functionname=strtolower($tabcols[1]).'_'.strtolower($tabcols[2]);
                                        $printhtml.=$templatemore->$functionname().substr($printcols[$i],$endcol+1);
                                        continue;
                                    }
                                    
                                     
                                    if(strtolower($tabcols[0])!='approvedetails'&&strtolower($tabcols[0])!='productdetails'&&strtolower($tabcols[0])!=strtolower($this->focus->module_name).'details'&&strtolower($tabcols[0])!='commission2payment'&&strtolower($tabcols[0])!='commissiondetails' && strtolower($tabcols[0]) !='serviceproduct')
                                    {
                                      
										/**
										 * 支持产品列增加其他非产品字段
										 * 如果连续两个非产品字段，则暂时无法支持
										 * @author Tujt 2015-01-08
										 */
                                        if($bolProduct && $isproductnum > 0){
											++ $isproductnum;
											$strProductHtml[] = join('_',$tabcols).']';
										}
                                        $bolProduct=false;
                                       //公司信息打印
                                    
                                        if(strpos(strtolower($colsinfo),'_company')>0&&strpos(strtolower($colsinfo),'_companyname')===false&&strpos(strtolower($colsinfo),'express_company')===false)
                                        {
                                           if($this->companyResult==null)
                                            {
                                                $sqlcompany='select * from ld_organizationdetails';
                                                $this->companyResult=$this->adb->pquery($sqlcompany,array());
                                            }
                                           $fieldname=$tabcols[1];
                                            
                                            $colvalue=$this->adb->query_result($this->companyResult,0,$fieldname);
                                            if($colvalue=="")
                                            {
                                                $colvalue=$this->replacespacevalue;
                                            }
                                           
                                            if(strtolower($fieldname)!='logoname')
                                                 $printhtml.=$colvalue.substr($printcols[$i],$endcol+1);
                                             else
                                             {
                                                $url = curPageURL();
												//chj 2021/1/26 44443: （https://61mis.com/kfbcrm [^]）（天娇网络）移动端使用导出成PDF，结果中不会显示logo、总计和大写金额。比如说SO241这个合同，使用合同预置模板。
												if(!empty($_REQUEST['weixin_pdf']) && $_REQUEST['weixin_pdf'] == 'yes'){
													$site_url = explode('WeiXinApp',$url);
												}else{
													$site_url = explode('index.php',$url);
												}
                                                
												global $site_URL;
                                                if((isset($_REQUEST['CreatePDF'])&&$_REQUEST['CreatePDF']==true) || isset($_REQUEST['CreateDOC'])&&$_REQUEST['CreateDOC']==true)
                                                    $printhtml.='<img src="'.$site_url[0].'dataCache/test/logo/'.$colvalue.'" border="0" style="width: 110px;height: 40px;margin:5px 5px 0 0px;" title="logo.png" alt="logo.png" >'.substr($printcols[$i],$endcol+1);
                                                else
                                                    $printhtml.='<img border="0" style="width: 110px;height: 40px;margin:5px 5px 0 0px;" title="logo.png" alt="logo.png" src="'.$site_url[0].'dataCache/test/logo/'.$colvalue.'">'.substr($printcols[$i],$endcol+1);
                                                
                                             }
                                                
                                             continue;
                                        }
                                        if(strtolower($tabcols[0])!='crmentity')
                                          {
                                            if('originbill_'.strtolower($this->tabname)==strtolower($fieldname).'_'.strtolower($curtabname))
                                            {
                                               $fieldsql='select fieldname,columnname,tablename,uitype,tabid  from ld_field where  fieldname=? and tablename=?  and tabid=?';
                                               $result=$this->adb->pquery($fieldsql,array('','',$this->tabid));
                                            }
                                            else
                                            {
                                                $fieldsql='select fieldname,columnname,tablename,uitype,tabid  from ld_field where  fieldname=? and tablename=?';
                                         
                                                switch(strtolower($curtabname)){
                                                    case 'management':
                                                        $result=$this->adb->pquery($fieldsql,array($fieldname,'ld_'.$tabcols[0].'_'.$tabcols[1]));
                                                         break;          
                                                    case 'mcommission':
                                                        $result=$this->adb->pquery($fieldsql,array($fieldname,'ld_'.$tabcols[0].'_'.$tabcols[1].'_'.$tabcols[2]));
                                                        break;
                                                    default:
                                                        
                                                         $result=$this->adb->pquery($fieldsql,array($fieldname,'ld_'.$tabcols[0]));
                                                        
                                                  }  
                                                
                                            }                                       
                                            
                                          } 
                                         else
                                         {
                                           
                                            $fieldsql='select fieldname,columnname,tablename,uitype,ld_field.tabid  from ld_field inner join ld_tab on ld_tab.tabid=ld_field.tabid where  ld_tab.name=? and fieldname=? and tablename=?';
                                            $result=$this->adb->pquery($fieldsql,array($curtabname,$fieldname,'ld_'.$tabcols[0]));

                                         }
                                            
                                          
                                         
                                         if($this->adb->num_rows($result)>0)
                                         {
                                           
                                            $uitype=$this->adb->query_result($result,0,'uitype');
                                             $fieldinfo=$cur_focus->fieldobj->getFieldInfoobjBykey('fieldname',$fieldname);
                                            
                                           // echo strtolower($fieldname).'_'.strtolower($curtabname);
										   //chj 2021/6/15 46305: https://61mis.com/KH/kh43499销售管理-合同订单-点击合同订单详情-更多-打印工具-选择送货单打印-无法显示联系人信息 [^]（已关联单据）
                                            if($tabcols[0] == 'contactdetails'){
												$curtabname = 'Contacts';
											}
                                             
                                            $colvalue=$this->adb->Query_result($printresult,0,strtolower($fieldname).'_'.strtolower($curtabname));//获取打印列值
                                             //zxm 预算单打印 预算单类型 预算单指标类型特殊翻译判断
                                             if(strtolower($fieldname)=='expensebudget_type'&&$curtabname=="ExpenseBudget"){
                                                 $colvalue = getFixedLabel($colvalue);
                                             }
                                             if(strtolower($fieldname)=='budget_indicators'&&$curtabname=="ExpenseBudget"){
                                                 $colvalue = getFixedLabel($colvalue);
                                             }
                                          if($uitype==230 || $uitype==231)//富文本框
                                           {
                                                $colvalue=decode_html($colvalue);
                                           }
                                           else if (Field::user_fields($uitype))
                                            {
                                                $colvalue=decode_html($colvalue);
                                                //zkt 20220714 BUG0053653 	https://kehu001.com/WX/kh49809/）报价单-报价单预置模板（PDF）-直接打印可以显示供方代表-PDF不显示 
                                                require_once globalStatic::$root_directory.'appCommon/appCommon.php';
                                                if(isKehu001ServerPc() == 'yes'&&$uitype == 53&&($_REQUEST['CreatePDF']==true || $_REQUEST['CreateDOC']==true)){
                                                    $colvalue = $colvalue;//kh001负责人字段打印为pdf或doc时，使用真实姓名对应的值
                                                }
                                                else{
                                                    $wx_userid=$this->adb->Query_result($printresult,0,strtolower($fieldname).'_wxuserid_'.strtolower($curtabname));//获取打印列值
                                                    $userid=$this->adb->Query_result($printresult,0,strtolower($fieldname).'_userid_'.strtolower($curtabname));//获取打印列值
                                                    $userobj=new Users();
                                                    $userobj->last_name=$colvalue;
                                                    $userobj->wx_userid=$wx_userid;
                                                  
                                                    $userobj->id=$userid;
                                                 
                                                    $colvalue=getUserlastName($userobj);
                                                }
                                            }
                                            else if($uitype==152||$uitype==180)
                                            {
                                                if($colvalue!='')
                                                {
                                                    $sql='select group_concat(groupname) from ld_groups where groupid in('.$colvalue.')';
                                                    $groupresult=$this->adb->pquery($sql,array());
                                                    if($this->adb->num_rows($groupresult)>0)
                                                    {
                                                        $colvalue=$this->adb->query_result($groupresult,0,0);
                                                        
                                                    }
                                                    
                                                }
                                            }
                                           else if($uitype==222)
                                           {
                                            
                                            //手写签名
                                            $query = 'select fieldname,path,`name`,datetime from ld_field_signature where tabid = ? and recordid = ? and fieldname = ?';
			                                $sign_result = $this->adb->pquery($query,array($this->tabid,$this->recordid,$fieldname));
                                           
                                            if($this->adb->num_rows($sign_result))
                                            {
												$url = curPageURL();
                                                $url = str_replace('WeiXinApp/','',$url);//移动端打印模板中图片路径设置  zxm2022-0126
                                                $site_url = explode('index.php',$url);

                                                $colvalue=$this->adb->query_result($sign_result,0,'path').$this->adb->query_result($sign_result,0,'name');
                                                $tmp_datetime=$this->adb->query_result($sign_result,0,'datetime');
                                                //38394: （51mis.com/kfbcrm）客户服务单模块明细界面>更多>打印：手写签名应该将签名日期带过来
                                                $a = rand(0,9999);
                                                $colvalue="<img width='35' height='56' align='absmiddle'  style='transform:rotate(-90deg);' src='".$site_url[0].$colvalue."?a=".$a."'/><br>".getFixedLabel('handwritingdatetime').'：'.$tmp_datetime;
                                            }
                                            
                                           }
                                           else if($uitype==560)
                                           {
                                                $sysdeploy = getSys_deploy(49);//数量
                                        		if(isset($sysdeploy['deploy_value']))
                                        			$lengthdecimaldigits = $sysdeploy['deploy_value'];
                                        		else
                                        			$lengthdecimaldigits  = 2;
                                                $colvalue=setNumberFormat($colvalue,$lengthdecimaldigits);
                                           }
                                           else if($uitype==27)
                                           {
                                                if($colvalue=='I')
                                                {
                                                    $colvalue='附件';
                                                }
                                                else
                                                {
                                                    $colvalue='链接';
                                                }
                                           }else if($uitype == 33){
												$colvalue = str_replace("|##|",",",$colvalue);//0019023: 客户-明细界面：多选框字段打印，两个值之间显示“ |##|”
										   }
                                           else if($uitype==69)
                                           {
                                               //ls 2022-04-06 【1002543】页面设置，增加“图片”字段类型【打印功能】【需要支持多个图片类型字段ld_seattachmentsrel.attachmentcolumnname，仅打印第一个】
                                              if($tabcols[2]==$this->tabname || 'ld_'.$tabcols[0] != $this->focus->table_name)
                                              {
                                                 $maintablename=$this->focus->table_name;
                                                  $maintableindex=$this->focus->table_index;
                                                  $modulename=$this->tabname;
                                                  $photo_id=$this->recordid;
                                              }
                                              else
                                              {
                                                 $photo_focus=CRMEntity::getInstance($tabcols[2]);
                                                  $maintablename=$photo_focus->table_name;
                                                  $maintableindex=$photo_focus->table_index;
                                                  $modulename=$tabcols[2];
                                                  $photo_id=$this->adb->Query_result($printresult,0,$tabcols[0].'_'.$maintableindex);
                                              }
                                             
                                              $query = "select ld_attachments.path,ld_attachments.newfile_name, ld_attachments.attachmentsid, ld_attachments.name ,
                                                        ld_crmentity.setype,storage_location,cloud_path from $maintablename left join ld_seattachmentsrel on 
                                                        ld_seattachmentsrel.crmid=$maintablename.$maintableindex inner join ld_attachments on
                                                        ld_attachments.attachmentsid=ld_seattachmentsrel.attachmentsid inner join ld_crmentity 
                                                        on ld_crmentity.crmid=ld_attachments.attachmentsid 
                                                        where ld_crmentity.setype=? and ld_seattachmentsrel.attachmentcolumnname=? and $maintableindex=?";

                                               $image_res = $this->adb->pquery($query, array($modulename." image", $fieldname, $photo_id));
                                   			  $image_id = $this->adb->query_result($image_res, 0, 'attachmentsid');
                                   			  $image_path = $this->adb->query_result($image_res, 0, 'path');
                                   			  $image_name = $this->adb->query_result($image_res, 0, 'newfile_name');
                                              $cloud_path=$this->adb->query_result($image_res, 0, 'cloud_path');
                                              $storage_location=$this->adb->query_result($image_res, 0, 'storage_location');
                                              $imgpath = $image_path . $image_id . "_" . $image_name;
                                              $deploy_values=getSys_deploy(75);
                                              $sizesinfo=explode(",",$deploy_values['deploy_value']);

                                              if($storage_location=='cos')
                                              {
                                                $colvalue='<img src="' . $cloud_path .  '" width="'.$sizesinfo[0].'" height="'.$sizesinfo[1].'" >';
                                              }
                                              else  if(!file_exists( iconv ( 'utf-8', 'gb2312',$imgpath )))
                                                {
                                                     $lastimg=explode('.',$image_name);
                                                    $imgpath=$image_path . $image_id . "_1.".$lastimg[sizeof($lastimg)-1] ;
                                                    if(!file_exists($imgpath))
                                                    {
                                                        $arr=array("ASCII","UTF-8","GB2312","GBK",'BIG-5');
                                                        $encode=mb_detect_encoding($image_name, $arr);

                                                        if($encode=='UTF-8')
                                                            $imgpath=$image_path . $image_name ;
                                                        else
                                                            $imgpath=$image_path . iconv ( 'gbk', 'utf-8',$image_name );
                                                        if (!file_exists($imgpath)) {
                                                            $imgpath=$image_path . iconv ( 'utf-8', 'gb2312',$image_name );
                                                        }
                                                        $colvalue='<img src="' . $imgpath .  '" width="'.$sizesinfo[0].'" height="'.$sizesinfo[1].'" >';
                                                    }
                                                }
                                                else
                                               
                                                    $colvalue='<img src="' . $imgpath .  '" width="'.$sizesinfo[0].'" height="'.$sizesinfo[1].'" >';
                                           }
                                           else if($fieldinfo&&$fieldinfo->istotalFldMoneyField())//金额，16988: 打印模板>库间调拨,关于字段值读取显示有误的问题
                                           {
                                            $colvalue=number_format($colvalue,2);
                                             
                                           }
                                           else if($fieldinfo&&$fieldinfo->istotalFldNumField()&&($fieldinfo instanceof ProductFields || $fieldinfo instanceof TabDetailToolFields))
                                           {
                                                    $sysdeploy = getSys_deploy(49);
													if(isset($sysdeploy['deploy_value']))
														$lengthdecimaldigits = $sysdeploy['deploy_value'];
													else
														$lengthdecimaldigits  = 2;
                                                 $colvalue=number_format($colvalue,$lengthdecimaldigits);
                                               
                                           }
                                           else if($uitype==7)
                                           {
                                                $typeofdata=$fieldinfo->getTypeOfData();
                                                $typeofdata_arr=explode(",",$typeofdata);
                                                if(sizeof($typeofdata_arr)>1)
                                                {
                                                    $colvalue=number_format($colvalue,$typeofdata_arr[1]);
                                                }
                                                else{
                                                    $colvalue=number_format($colvalue,2);
                                                }
                                           }
                                           else if($uitype==102||$uitype==150)//回款计划相关对象,付款计划采购订单
                                           {
                                                if(!empty($colvalue))
                                                {
                                                           //7024: 付款计划/回款计划>明细,关于打印模板变量读取有误的问题
                                                            $settype=getSalesEntityType($colvalue);
                                                           
                                                           $entitynames=getEntitynameByModulename($settype);
                                                           $field_href_name=$entitynames['fieldname'];
                                                           $tablename=$entitynames['tablename'];
                                                           $entity_fieldid=$entitynames['entityidfield'];
                                        
                                                            $sql="select $field_href_name  from $tablename  where $entity_fieldid =$colvalue";
                                                            $origin_result=$this->adb->pquery($sql,array());
                                                            if($this->adb->num_rows($origin_result)>0)
                                                            {
                                                                $colvalue=$this->adb->query_result($origin_result,0,0);
                                                            }
                                                }
                                           }
                                           else if($uitype==200)
                                           {
                                            //16994: 打印模板>采购订单,关于打印预览中源单字段的值读取有误的问题
                                                if(get_file_address($this->tabname,'ProductDetails'))
                                                {
                                                    $sql=" select DISTINCT entitytype,entitytypeid from $detailtable  where id=".$this->recordid;
                                                    $source_result=$this->adb->pquery($sql,array());   
                                                    for($source_tmp=0;$source_tmp<$this->adb->num_rows($source_result);$source_tmp++)
                                                        {
                                                            
                                                            $source_id=$this->adb->query_result($source_result,$source_tmp,1);
                                                            $source_setype=$this->adb->query_result($source_result,$source_tmp,0);
                                                            if(!empty($source_id))
                                                            {
                                                              
                                                                $entitynames=getEntitynameByModulename($source_setype);
                                                                $field_href_name=$entitynames['fieldname'];
                                                                $tablename=$entitynames['tablename'];
                                                                $entity_fieldid=$entitynames['entityidfield'];
                                                                $sql="select $field_href_name  from $tablename  where $entity_fieldid =$source_id";
                                                                $origin_result=$this->adb->pquery($sql,array());
                                                                if($this->adb->num_rows($origin_result)>0)
                                                                {
                                                                   $source[]=$this->adb->query_result($origin_result,0,0);
                                                                }
                                                            }
                                                            
                                                        }
                                                        if(sizeof($source)>0)
                                                        {
                                                            $colvalue=implode(';',$source);
                                                        }
                                                }
                                           }
                                           else if($uitype==201)
                                           {
                                            //16994: 打印模板>采购订单,关于打印预览中源单字段的值读取有误的问题
                                                if(get_file_address($this->tabname,'ProductDetails'))
                                                {
                                                    $sql=" select DISTINCT entitytype,entitytypeid from $detailtable  where id=".$this->recordid;
                                                    $source_result=$this->adb->pquery($sql,array());   
                                                    for($source_tmp=0;$source_tmp<$this->adb->num_rows($source_result);$source_tmp++)
                                                        {
                                                            
                                                            $source_id=$this->adb->query_result($source_result,$source_tmp,1);
                                                            $source_setype=$this->adb->query_result($source_result,$source_tmp,0);
                                                            if(!empty($source_id))
                                                            {
                                                              
                                                                $entitynames=getEntitynameByModulename($source_setype);
                                                                $field_href_name=$entitynames['fieldname'];
                                                                $tablename=$entitynames['tablename'];
                                                                $entity_fieldid=$entitynames['entityidfield'];
                                                                $sql="select $field_href_name  from $tablename  where $entity_fieldid =$source_id";
                                                                $origin_result=$this->adb->pquery($sql,array());
                                                                if($this->adb->num_rows($origin_result)>0)
                                                                {
                                                                   $source[]=$this->adb->query_result($origin_result,0,0);
                                                                }
                                                            }
                                                            
                                                        }
                                                        if(sizeof($source)>0)
                                                        {
                                                            $colvalue=implode(';',$source);
                                                        }
                                                }
                                           }
                                           else if($uitype==202)
                                           {
                                                    //16994: 打印模板>采购订单,关于打印预览中源单字段的值读取有误的问题
                                                    if(get_file_address($this->tabname,'ProductDetails'))
                                                    {
                                                        $focus=CRMEntity::getInstance($this->tabname);
                                                        $source_setype='';
                                                        $sql=" select group_concat(source_list) as source_list,entitytype from ( select group_concat(ifnull(entitytypeid,0)) as source_list, entitytype from $detailtable
                                                    
                                                          where id=".$this->recordid .'  union all 
                                                          select  source_list,entitytype from 
                                                          '.$focus->table_name.' where '.$focus->table_index.'='.$this->recordid .') as tmp
                                                          where entitytype is not null and entitytype<>""' ;
                                                        $source_result=$this->adb->pquery($sql,array());
                                                        
                                                        for($source_tmp=0;$source_tmp<$this->adb->num_rows($source_result);$source_tmp++)
                                                        {
                                                            $source_ids=explode(',',$this->adb->query_result($source_result,$source_tmp,'source_list'));
                                                            $source_setype=$this->adb->query_result($source_result,$source_tmp,'entitytype');
                                                           $source_ids=array_unique($source_ids);
                                                           foreach($source_ids as $tmpsourceid)
                                                            {
                                                               
                                                                $entitynames=getEntitynameByModulename($source_setype);
                                                                $field_href_name=$entitynames['fieldname'];
                                                                $tablename=$entitynames['tablename'];
                                                                $entity_fieldid=$entitynames['entityidfield'];
                                                                $sql="select $field_href_name  from $tablename  where $entity_fieldid =$tmpsourceid";
                                                                $origin_result=$this->adb->pquery($sql,array());
                                                               
                                                                if($this->adb->num_rows($origin_result)>0)
                                                                {
                                                                   $source[]=$this->adb->query_result($origin_result,0,0);
                                                                }
                                                                $tab_china=getTranstab($source_setype);
                                                            }
                                                            
                                                        }
                                                        
                                                        if(sizeof($source)>0)
                                                        {
                                                           //$tab_china.':'.
                                                            $colvalue=implode(';',$source);
                                                        }
                                                    }
                                                    else
                                                    {
                                                        if(!empty($colvalue))
                                                        {
                                                            //16955: 费用报销>明细,关于打印模板时读取字段值错误的问题
                                                            $settype=getSalesEntityType($colvalue);
                                                            if($settype=='ServiceContracts')
                                                            {
                                                                $entitynames=getEntitynameByModulename('ServiceContracts');
                                                                $field_href_name=$entitynames['fieldname'];
                                                                $tablename=$entitynames['tablename'];
                                                                $entity_fieldid=$entitynames['entityidfield'];
                                                               
                                                            }
                                                            else if($settype=='SalesOrder')
                                                            {
                                                                $entitynames=getEntitynameByModulename('SalesOrder');
                                                                $field_href_name=$entitynames['fieldname'];
                                                                $tablename=$entitynames['tablename'];
                                                                $entity_fieldid=$entitynames['entityidfield'];
                                                            }
                                                            $sql="select $field_href_name  from $tablename  where $entity_fieldid =$colvalue";
                                                            $origin_result=$this->adb->pquery($sql,array());
                                                            if($this->adb->num_rows($origin_result)>0)
                                                            {
                                                                $colvalue=$this->adb->query_result($origin_result,0,0);
                                                            }
                                                        }
                                                    }
                                                    
                                           }
                                           else if($uitype==1&&$fieldname=='publicaccount'&&$this->tabname=='Accounts')
                                           {
                                            //16982: 打印模板>客户,关于字段值读取有误的问题
                                             if($colvalue>0)
                                             {
                                                $colvalue='是';
                                             }
                                             else 
                                             {
                                                $colvalue='否';
                                             }
                                           }
                                           else if($uitype==1&&$fieldname=='filesize')
                                           {
                                                //17009: 知识管理>明细,关于预览模板时字段读取有误的问题
                                                $colvalue=($colvalue/1024).'KB';
                                                if($colvalue>=1024)
                                                {
                                                    $colvalue=(number_format($colvalue/1024,2)).'MB';
                                                }
                                           }
                                           else if($uitype==242)
                                           {    
                                              $sql_announce='select ld_users.last_name from ld_receipts INNER JOIN ld_users on ld_receipts.userid=ld_users.id  where ld_receipts.id=? and setype=?';
                                              $announce_result=$this->adb->pquery($sql_announce,array($this->recordid,'publicannouncement'));
                                              for($announce_i=0;$announce_i<$this->adb->num_rows($announce_result);$announce_i++)
                                              {
                                                $announce_users[]=$this->adb->query_result($announce_result,$announce_i,0);
                                              }
                                              $colvalue=implode(',',$announce_users);
                                           }
                                           else if($uitype==86)//日期
                                           {
                                            
                                            //16982: 打印模板>客户,关于字段值读取有误的问题
                                              $date_format_value=date("Y-m-d",strtotime($colvalue));
                                             
                                              if($date_format_value<='1970-01-01')
                                              {
                                                $colvalue='';
                                              }
                                           }
                                          
                                           else if($uitype==117)
                                           {
                                              global $app_currency_strings;
                                              $colvalue=$app_currency_strings[$colvalue];
                                           }
										   elseif($uitype == 71 || $uitype == 72){//金额字段，增加货币标识
												$currency_symbol = $this->adb->query_result($printresult, 0, 'currency_symbol');
												if(!empty($currency_symbol)){
													$colvalue = $currency_symbol.$colvalue;
												}
										   }
                                           else if ($uitype==252)//转入账户
                                           {	//ls 2021-09-29 0048117: （81mis.com/kfbcrm）（需要补丁）出纳体现单》打印，转入账户打印时显示id，而不是账户名
                                               if($colvalue!='' && is_numeric($colvalue))
                                               {
                                                   $sql='select accountname from ld_bankaccountset where bankaccountsetid = ?';
                                                   $result=$this->adb->pquery($sql,array($colvalue));
                                                   if($this->adb->num_rows($result)>0)
                                                   {
                                                       $colvalue=$this->adb->query_result($result,0,0);

                                                   }
                                               }
                                           }
                                           else if ($uitype==1600)//负责人、创建人所在部门
                                           {	//ls 2021-09-29 48123: （测试账套）客户详情界面》打印，模板设置的是打印负责人部门字段，但是打印出来显示一个数字
                                               //edit:duan date:2021-10-8 reason:函数名与原有函数重名，增加后缀_new
                                               if($colvalue!='')
                                               {
                                                   $colvalue = getGroupName_new($colvalue);
                                               }
                                           }
                                           else if ($uitype == 1500 || $uitype == 1501)//二维码之内容码、链接码
                                           {//ls 2021-12-31 0049466: 跟进记录》打印，设置的内容码 二维码字段打印不出来
                                               $tmpfield_result = $this->adb->pquery("select fieldid from ld_field where tabid=? and fieldname=?",array($this->tabid,$fieldname));
                                               $tmpfieldid = $this->adb->query_result($tmpfield_result,0,'fieldid');

                                               $template_sql = "select * from ld_qrcode_template where fieldid=?";
                                               $template_res = $this->adb->pquery($template_sql,[$tmpfieldid]);
                                               $template_nums = $this->adb->num_rows($template_res);

                                               if($template_nums > 0){ //有值时才处理
                                                   $template = $this->adb->query_result_rowdata($template_res,0);
                                                   $template_content = $template['template_content'];
                                                   if (empty($template_content)) {
                                                       $template_content = $template['replacesplacevalue'];
                                                   }
                                                   $colvalue = $this->getFieldQrCode($template_content,$tmpfieldid,$uitype);
                                               }

                                           }
                                           else if ($uitype == 1502)//二维码之移动单据详情码
                                           {
                                               $module = getTabModuleName($this->tabid);
                                               $modulelabel = getTranstab($module);

                                               $tmpfield_result = $this->adb->pquery("select fieldid from ld_field where tabid=? and fieldname=?",array($this->tabid,$fieldname));
                                               $tmpfieldid = $this->adb->query_result($tmpfield_result,0,'fieldid');

                                               $content_arr = ['modulelabel'=>$modulelabel,'modulename'=>$module,'recordid'=>$this->recordid];
                                               $template_content = json_encode($content_arr);

                                               $colvalue = $this->getFieldQrCode($template_content,$tmpfieldid,$uitype);
                                           }
                                           else if ($uitype == 1503){
                                                //打印模板加入表单码
                                               $module = getTabModuleName($this->tabid);
                                               $tmpfield_result = $this->adb->pquery("select fieldid from ld_field where tabid=? and fieldname=?",array($this->tabid,$fieldname));
                                               $tmpfieldid = $this->adb->query_result($tmpfield_result,0,'fieldid');
                                               $colvalue = $this->getFormQrCode($module,$tmpfieldid,$uitype,$this->recordid);
                                           }
                                           elseif($uitype==56){
                                               //引用的复选框字段显示0、1修改
											   //chj 2022/7/18 合同模块中，S014是否字段显示为是，合同预置模板-打印模板打印出来的显示的是否
                                              /* if($colvalue == 1){
                                                   $colvalue = getFixedLabel('YES');
                                               }else{
                                                   $colvalue = getFixedLabel('NO');
                                               }*/
                                           }
                                           else
                                           {
                                            
                                             $colvalue=str_replace("\n", "<br>", $colvalue);
                                               
                                           }
                                            
                                           if($colvalue=='')
                                            {
                                                $colvalue=$this->replacespacevalue;
                                            }
                                             $lineenter=explode('\n',$colvalue);//是否包含换行符
                                               if(sizeof($lineenter))
                                               {
                                                 $pcolvalue=str_replace("\n","<br>",$colvalue);
                                               }
                                              
                                            $printhtml.=$colvalue.substr($printcols[$i],$endcol+1);
                                            
                                         }
                                         elseif(strtolower($tabcols[0])=='table'&&strtolower($tabcols[1])=='totalquantity')
                                         {
                                            //edit:can 06210: 新增“出库单”、“入库单”打印模板时，产品信息中缺少“数量合计”、“备注”打印变量，希望添加。
                                            $sql=" select sum(quantity) from $detailtable where id=".$this->recordid .' group by id';
                                            $quantityreuslt=$this->adb->pquery($sql,array());
                                            $totalquantity=$this->adb->query_result($quantityreuslt,0,0);
											$totalquantity = setNumberFormat($totalquantity,$lengthdecimaldigits);
                                            $printhtml.=$totalquantity.substr($printcols[$i],$endcol+1);
                                         }
                                         elseif(file_exists(globalStatic::$root_directory.'modules/'.$this->tabname.'/PrintTotal.php'))
                                         {
                                             
                                            if(strpos(strtolower($printcols[$i]),'total_table')>0)
                                             {
                                                //edit:can 2020-10-10 042861: （http://120.195.85.78:85/crm [^]）（力九和塑胶工业有限公司客户问题）合同订单模块>选择编号为“SO19810”进入明细界面>更多>选择“合同预置模板”进行打印：打印后“总计”金额显示不对。（如图）
                                                $colvalue=number_format($this->adb->Query_result($printresult,0,'total_table'),2,'.','');//获取打印列值
												/**
												 * 多币种，总计字段增加金额符号
												 * @author Tujt 2015-01-08
												 */
												$currency_symbol = $this->adb->Query_result($printresult,0,'currency_symbol');
												if(!empty($currency_symbol)){
													$colvalue = $currency_symbol.$colvalue;
												}
                                             }
                                             if(strpos(strtolower($printcols[$i]),'total_big_table')>0)
                                             {
                                               
                                                $colvalue=$this->adb->Query_result($printresult,0,'total_table');//获取打印列值
                                                
                                                $colvalue=$this->ConvertTotalToUpper($colvalue);
                                             }
                                            
                                             if(strtolower($fieldname)=='year'||strtolower($fieldname)=='month'||strtolower($fieldname)=='today')
                                             {
                                               //获取回款计划日期的年月日
                                                $colvalue=$this->adb->Query_result($printresult,0,strtolower($fieldname).'_'.strtolower($curtabname));
                                             }
                                             if($colvalue=='')
                                             {
                                                $colvalue=$this->replacespacevalue;
                                             }
                                             $printhtml.=$colvalue.substr($printcols[$i],$endcol+1);
                                             //34833: 合同订单打印问题：当打印模板中字段未启用时，打印错误
                                             $colvalue="";
                                         }
                       
                                  }
                                 else 
                                 {
                                 

                                    if(strtolower($tabcols[0])=='productdetails')//如果是产品
                                    {
                                       
										/**
										 * 产品字段时循环递增静态变量$isproductnum
										 * @author Tujt 2015-01-08
										 */
										static $isproductnum;
										if(!$isproductnum) $isproductnum = 0;
										++ $isproductnum;
										/**
										 * 判断当前打印模板中是否有套餐打印字段名
										 * @project PROT127 爱哆哆需求1：产品套餐
										 * @author Tujt 2014-12-03
										 */
                                         if(stripos($line,'_bomname_products') > 0){
											$bolBomPrint = true;
										 }
                                         
                                         $bolProduct=true;
                                         if(strpos(strtolower($printcols[$i-1]),'<td')>0)
                                            $prevtdline=$printcols[$i-1];

                                         //产品合计人民币大写
                                         if(strpos(strtolower($printcols[$i]),'total_big_products')>0)
                                            {
                                               $bolProduct=false;
                                               //产品合计
                                                $bolProduct=false;
                                                //	0028609: 带有产品分录模块的单据->打印时，小计变量[var.productdetails_total_products]应该取价税合计的小计
                                                $tmpsql='select subtotal from '.$this->focus->table_name.' where '.$this->focus->table_index.'=?';
                                                
                                                $tmp_result=$this->adb->pquery($tmpsql,array($this->recordid));
                                                $subtotal=$this->adb->query_result($tmp_result,0,0);
                                                
											    $colvalue=number_format($subtotal, 2,'.','');//获取打印列值
                                                $printhtml.=$this->ConvertTotalToUpper($colvalue);
                                            }
                                         
                                           elseif(strpos(strtolower($printcols[$i]),'s_total_products')>0)
                                           {
                                               //产品合计
                                                $bolProduct=false;
                                                //	0028609: 带有产品分录模块的单据->打印时，小计变量[var.productdetails_total_products]应该取价税合计的小计
                                                $tmpsql='select subtotal from '.$this->focus->table_name.' where '.$this->focus->table_index.'=?';
                                                
                                                $tmp_result=$this->adb->pquery($tmpsql,array($this->recordid));
                                                $subtotal=$this->adb->query_result($tmp_result,0,0);
                                                $printhtml.=number_format($subtotal,2).substr($printcols[$i],$endcol+1);
                                           }
                                           else
                                           {
                                             $strProductHtml[]= $prevtdline.$printcols[$i];
                                           }
                                           
                                    }
                                    $detailtable=$this->focus->Detail_table;
                               
                                    if(strtolower($tabcols[0])=='commission2payment'||strtolower($tabcols[0])=='commissiondetails'){
									
										$bolCommission=true;
										$strCommissionHtml[]= $prevtdline.$printcols[$i];
									}
                                    else if(strtolower($tabcols[0])=='expensedetails')//如果是费用报销明细
                                    {
                                        
                                        $bolExpense=true;
                                        //费用报销合计人民币大写
                                         if(strpos(strtolower($printcols[$i]),'total_big_expense')>0)
                                            {
                                               $bolExpense=false;
                                             
                                                $printhtml.=$this->ConvertTotalToUpper($this->expenseTotal).substr($printcols[$i],$endcol+1);
                                            }
                                         
                                           elseif(strpos(strtolower($printcols[$i]),'s_total_expense')>0)
                                           {
                                               //费用报销合计
                                                $bolExpense=false;
                                                $printhtml.=$this->expenseTotal.substr($printcols[$i],$endcol+1);
                                           }
                                           else
                                           {
                                            
                                             $strExpenseHtml[]= $prevtdline.$printcols[$i];
                                           }
                                    }
                                    else 
                                    {
                                       
                                         if('ld_'.strtolower($tabcols[0])==$detailtable||strtolower($tabcols[0])==strtolower($this->focus->module_name).'details'){
									
    										$boldetailPrint=true;
    										$strDetailHtml[]= $prevtdline.$printcols[$i];
    									}
                                    }
                                    
                                    if(strtolower($tabcols[0])=='approvedetails')//如果是审批历史明细
                                    {
                                       
                                        $bolApprove=true;
                                        $strApproveHtml[]= $prevtdline.$printcols[$i];
                                           
                                    }
                                 }
                            }
                            else
                            {
                                $printhtml.=$printcols[$i];
                            }
                        }
                        else
                        {
                            $printhtml .= $printcols[$i];
							if($bolBomPrint && $bolProduct){
								if(strpos($printcols[$i],'rowspan')>0){
									$bomprinthtml = $printcols[$i];;
								}
							}
                        }
                    }
                }
                else
                {
                    $printhtml.=$line;
                   
                }
                
                   
          }

          if(!empty($this->reminds_ruleid))
          {
            @unlink(globalStatic::$root_directory.'templatePrintFile/'.$printfilename);
          }
          return $printhtml;
    }
   
    /**
     * edit;can
     * date:20130816
     * reason:利用正则表达式获取[]内容
     * */
    private function getPrintColumnInfo($str)
    {
        $result = array();
       preg_match_all("/(?:\[)(.*)(?:\])/i",$str, $result);

       return $result;
    }
    /**
    *edit:can
    *date;20130816
    *reason:创建打印模板的SQL语句
    **/
    private function createPrintSQL()
    {
      
         $templateprintsql=new TemplatePrintSql($this->tabname,$this->recordid);
         return $templateprintsql->CreateSql($this->printfilename);
        
    }
    //ls 2021-12-31 0049466: 跟进记录》打印，设置的内容码 二维码字段打印不出来(getFieldQrCode.php)
     private function getFieldQrCode($template_content,$fieldid,$uitype)
     {
         include_once globalStatic::$root_directory.'marketplateform/phpqrcode/phpqrcode.php';
         if($uitype==1501){
             //链接码
             $module = getTabModuleName($this->tabid);
             //ls 2022-01-19 0049731: （http://36.7.144.104:85/crm/index.php [^]）（客户问题）资产管理》打印》打印出来后，扫描二维码提示错误
             $corpurl = $_SERVER['REQUEST_SCHEME'].'://'.$_SERVER['HTTP_HOST'] .rtrim($_SERVER['PHP_SELF'],'index.php');
             $template_content = $corpurl."WeiXinApp/fieldqrcodelink.php?module=$module&fieldid=$fieldid&uitype=$uitype&recordid=$this->recordid";
         }else{
             //内容码
             $template_content = strip_tags(htmlspecialchars_decode(trim($template_content)));//内容
             $template_content = str_replace('&nbsp;',' ',$template_content);
         }

         $level = 'L';// 纠错级别：L、M、Q、H
         $size = 10;//元素尺寸
         $margin = 1;//边距
         if(!is_dir(globalStatic::$root_directory.'storage/phpqrcode/')){
             mkdir(globalStatic::$root_directory.'storage/phpqrcode/',0777);
         }
         if(file_exists(globalStatic::$root_directory.'storage/phpqrcode/'.$this->recordid.$fieldid.$uitype.'.png')){
             unlink(globalStatic::$root_directory.'storage/phpqrcode/'.$this->recordid.$fieldid.$uitype.'.png');
         }
         $outfile = globalStatic::$root_directory.'storage/phpqrcode/'.$this->recordid.$fieldid.$uitype.'.png';
         $saveandprint = false;// true直接输出屏幕  false 保存到文件中
         $back_color = 0xFFFFFF;//白色底色
         $fore_color = 0x000000;
         $QRcode = new QRcode();
         //生成png图片
         $QRcode->png($template_content, $outfile, $level, $size, $margin, $saveandprint, $back_color, $fore_color);
         $qrpath = 'storage/phpqrcode/'.$this->recordid.$fieldid.$uitype.'.png';
         $colvalue = '<img style="width:100px;" border=0 src="'.$qrpath.'">';
         return $colvalue;
     }
     //duan   获取表单码图片
     public function getFormQrCode($module,$fieldid,$uitype,$record){
        $_REQUEST['fieldid'] = $fieldid;
        $_REQUEST['fieldid'] = $fieldid;
        $_REQUEST['module'] = $module;
        $_REQUEST['recordid'] = $record;
        $_REQUEST['print_qrcode'] = 'yes';
        //duan 为了避免出现当前单据打印时未生成表单码的问题，调用生成表单码的文件
        require_once(globalStatic::$root_directory.'modules/lingdang/getFormQrcode.php');
        $colvalue = '<img style="width:100px;" border=0 src="'.$imgsrc.'">';
        return $colvalue;
     }

     public function getImageListPrint($columnname,$lineitem_id){
         //ls 2022-06-13 【ID1002721】单据分录定制，增加“图片”字段类型【非产品分录图片字段打印，仅打印第一个】
         $Detail_table_scf = $this->focus->Detail_table_scf;//明细自定义表
         $query = "select ld_detailattachments.id,ld_detailattachments.path,ld_detailattachments.newfile_name,ld_detailattachments.id,ld_detailattachments.`name`,
ld_detailattachments.storage_location,ld_detailattachments.cloud_path from ld_detailattachments inner join $Detail_table_scf on $Detail_table_scf.lineitem_id= ld_detailattachments.lineitem_id
where ld_detailattachments.crmid=? and ld_detailattachments.columnname=? and ld_detailattachments.lineitem_id=?";

         $image_res = $this->adb->pquery($query, array($this->recordid,$columnname,$lineitem_id));
         $image_id = $this->adb->query_result($image_res, 0, 'id');
         $image_path = $this->adb->query_result($image_res, 0, 'path');
         $image_name = $this->adb->query_result($image_res, 0, 'newfile_name');
         $cloud_path=$this->adb->query_result($image_res, 0, 'cloud_path');
         $storage_location=$this->adb->query_result($image_res, 0, 'storage_location');
         $imgpath = $image_path . $image_id . "_" . $image_name;
         $deploy_values=getSys_deploy(75);
         $sizesinfo=explode(",",$deploy_values['deploy_value']);

         if($storage_location=='cos')
         {
             $pcolvalue='<img src="' . $cloud_path .  '" width="'.$sizesinfo[0].'" height="'.$sizesinfo[1].'" >';
         }
         else  if(!file_exists( iconv ( 'utf-8', 'gb2312',$imgpath )))
         {
             $lastimg=explode('.',$image_name);
             $imgpath=$image_path . $image_id . "_1.".$lastimg[sizeof($lastimg)-1] ;
             if(!file_exists($imgpath))
             {
                 $arr=array("ASCII","UTF-8","GB2312","GBK",'BIG-5');
                 $encode=mb_detect_encoding($image_name, $arr);

                 if($encode=='UTF-8')
                     $imgpath=$image_path . $image_name ;
                 else
                     $imgpath=$image_path . iconv ( 'gbk', 'utf-8',$image_name );
                 if (!file_exists($imgpath)) {
                     $imgpath=$image_path . iconv ( 'utf-8', 'gb2312',$image_name );
                 }
                 $pcolvalue='<img src="' . $imgpath .  '" width="'.$sizesinfo[0].'" height="'.$sizesinfo[1].'" >';
             }
         }
         else{
             $pcolvalue='<img src="' . $imgpath .  '" width="'.$sizesinfo[0].'" height="'.$sizesinfo[1].'" >';

         }

         return $pcolvalue;
     }
    
 }

?>